<?php
/***************************************************************************
 *                            usercp_register.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: usercp_register.php,v 1.20.2.35 2003/01/10 21:28:08 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
	exit;
}

// ---------------------------------------
// Load agreement template since user has not yet
// agreed to registration conditions/coppa
//
function show_coppa()
{
	global $userdata, $template, $lang, $phpbb_root_path, $phpEx;

	$template->set_filenames(array(
		'body' => 'agreement.tpl')
	);

	$template->assign_vars(array(
		'REGISTRATION' => $lang['Registration'],
		'AGREEMENT' => $lang['Reg_agreement'],
		"AGREE_OVER_13" => $lang['Agree_over_13'],
		"AGREE_UNDER_13" => $lang['Agree_under_13'],
		'DO_NOT_AGREE' => $lang['Agree_not'],

		"U_AGREE_OVER13" => "profile.$phpEx?mode=register&amp;agreed=true&amp;sid=" . $userdata['session_id'],
		"U_AGREE_UNDER13" => "profile.$phpEx?mode=register&amp;agreed=true&amp;coppa=true&amp;sid=" . $userdata['session_id'])
	);

	$template->pparse('body');

}
//---------------------------------------------------------------------------
//  ʵ带  ø ϱ Լ....
//---------------------------------------------------------------------------
function user_field($use_temp,$switch_sel,$switch_req) {
    global $template;
    if (!empty($use_temp)) {
       ($use_temp == 1) ? $template->assign_block_vars("$switch_sel", array()) : $template->assign_block_vars("$switch_req", array());
    }
    return;
}
//------------------------------------------------------------------- ֹüũ 
function Check_jumin($jumin1,$jumin2) {
    $jumin = trim($jumin1 . $jumin2);
	$lastnumber = substr($jumin,12,1); 
	$add = '234567892345';
	$length = strlen($jumin); 
	$total = 0; 
	if ($length <> 13) {
		msg("ֹεϹȣ ڸ Ʋϴ.");
		exit;
	} 
	for ($i = 0; $i < 12; $i++) { 
		$total = $total + (substr($jumin,$i,1)*substr($add,$i,1)); 
	} 
	$rest = $total%11; 
	$result = 11 - $rest; 
	if ($result == 10) {$result = 0;}
	if ($result == 11) {$result = 1;} 
	if ($result <> $lastnumber) {
		msg("߸ ֹεϹȣ Դϴ.");
		exit;
	} 
} 
//--------------------------------------------------------------------- ȭȣ üũ
function Check_phone($phone1,$phone2,$phone3,$str1,$str2) {
    Check_null($phone1, "${str2} ֽñ ٶϴ.");
    Check_null($phone2, "${str1}  Էּ");
    Check_num($phone2, "${str1}  ڷθ Էϼž մϴ.");
    if (strlen($phone2) < 3) { msg("${str1}  3ڸ ̻ 4 ڸ  ڷ Էϼž մϴ."); } 
    Check_null($phone3, "${str1} ȣ Էּ");
    Check_num($phone3, "${str1} ȣ ڷθ Էϼž մϴ.");
    if (strlen($phone3) < 4) { msg("${str1} ȣ 4ڸ ڷ Էϼž մϴ."); } 
}
//--------------------------------------------------------------------- üũ
function Check_null($check,$str) {
	if ((empty($check)) || $check =='') {
	   msg("${str}");
	   exit;
	}
}
//--------------------------------------------------------------------- üũ 
function Check_num($num,$str) {
	$num = trim($num);
	if (eregi("[^0-9]", $num)) { msg("Է¿ : ${str}"); }
}

//+-------------------------------------------------------------------+
//| üũ                                                        |
//+-------------------------------------------------------------------+
function Check_Form() {
    global $board_config,$realname,$jumin1,$jumin2,$mphone1,$mphone2,$mphone3,$hphone1,
           $hphone2,$hphone3,$location,$location2,$occupation,$b_year,$b_md,$b_day;
// ------------------------------------------------------------------ ̸ üũ
    if ($board_config['use_realname'] == 2) {
        $realname = trim($realname);
        if (!$realname) { msg("̸ Էּ!"); }
	    if (ereg("(^[a-z]+([0-9a-z])$)", $realname)) {
		    msg("̸ ѱ۷ ۼϼž մϴ!");
		    exit;
        }
    }
// ------------------------------------------------------------------ ֹε ȣ üũ
    if ($board_config['use_jumin'] == 2) {
       (empty($jumin1) || empty($jumin2)) ? msg("ֹεϹȣ Էϼ.") : Check_jumin($jumin1,$jumin2);
    }
    if (!empty($jumin1) || !empty($jumin2)) { Check_jumin($jumin1,$jumin2); }
// ------------------------------------------------------------------- ȭüũ
    if ($board_config['use_mphone'] == 2) {
        Check_phone($mphone1,$mphone2,$mphone3,'ȭ','ȣ');
    } else {
        if (!empty($mphone1) || !empty($mphone2) || !empty($mphone3)) {
            Check_phone($mphone1,$mphone2,$mphone3,'ȭ','ȣ');
        }
    }
    if ($board_config['use_hphone'] == 2) {
        Check_phone($hphone1,$hphone2,$hphone3,'ڵ','̵Ż');
    } else {
        if (!empty($hphone1) || !empty($hphone2) || !empty($hphone3)) {
            Check_phone($hphone1,$hphone2,$hphone3,'ڵ','̵Ż');
        }
    }
// ------------------------------------------------------------------- ּüũ
    if($board_config['use_from'] == 2) {
       Check_null($location,'ּҸ Է ̽ϴ.');
       Check_null($location2,' ּҸ ԷϽñ ٶϴ.');
    }
// ------------------------------------------------------------------- üũ
    if ($board_config['use_occ'] == 2) {
        Check_null($occupation,'  Ͻñ ٶϴ.');
    }
// -------------------------------------------------------------------- üũ
    if ($board_config['use_birth'] == 2) {

        if (empty($b_year)) { msg(" Էϼ."); }
        if (strlen($b_year) < 4) { msg(" 4ڸ ڷ Էϼž մϴ."); }
        if (empty($b_md)) { msg(" ּ"); }
        if (empty($b_day)) { msg(" ּ"); }

    } else {

        if (!empty($b_year) || !empty($b_md) || !empty($b_day)) {
            if (strlen($b_year) < 4) { msg(" 4ڸ ڷ Էϼž մϴ."); }
            else if (empty($b_md)) { msg(" ּ"); }
            else if (empty($b_day)) { msg(" ּ"); }
            else if ((empty($b_year)) && (!empty($b_md)) && (!empty($b_day))) { msg(" Էּ"); } 
        }
    }
    return;
} 
//---------------------------------------------------------------------//  üũ  //

$error = FALSE;
$page_title = ( $mode == 'editprofile' ) ? $lang['Edit_profile'] : $lang['Register'];

if ( $mode == 'register' && !isset($HTTP_POST_VARS['agreed']) && !isset($HTTP_GET_VARS['agreed']) )
{
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	show_coppa();

	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
}

$coppa = ( empty($HTTP_POST_VARS['coppa']) && empty($HTTP_GET_VARS['coppa']) ) ? 0 : TRUE;

//
// Check and initialize some variables if needed
//
if (
	isset($HTTP_POST_VARS['submit']) ||
	isset($HTTP_POST_VARS['avatargallery']) ||
	isset($HTTP_POST_VARS['submitavatar']) ||
	isset($HTTP_POST_VARS['cancelavatar']) ||
	$mode == 'register' )
{
	// session id check
	if ($sid == '' || $sid != $userdata['session_id'])
	{
		message_die(GENERAL_ERROR, 'Invalid_session');
	}

	include($phpbb_root_path . 'includes/functions_validate.'.$phpEx);
	include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
	include($phpbb_root_path . 'includes/functions_post.'.$phpEx);

	if ( $mode == 'editprofile' )
	{
		$user_id = intval($HTTP_POST_VARS['user_id']);
		$current_email = trim(htmlspecialchars($HTTP_POST_VARS['current_email']));
	}

	$strip_var_list = array('username' => 'username', 'email' => 'email', 'icq' => 'icq', 'aim' => 'aim', 'msn' => 'msn', 'yim' => 'yim', 'website' => 'website', 'location' => 'location', 'location2' => 'location2', 'occupation' => 'occupation', 'interests' => 'interests');

	// Strip all tags from data ... may p**s some people off, bah, strip_tags is
	// doing the job but can still break HTML output ... have no choice, have
	// to use htmlspecialchars ... be prepared to be moaned at.
	while( list($var, $param) = @each($strip_var_list) )
	{
		if ( !empty($HTTP_POST_VARS[$param]) )
		{
			$$var = trim(htmlspecialchars($HTTP_POST_VARS[$param]));
		}
	}

	$trim_var_list = array('cur_password' => 'cur_password', 'new_password' => 'new_password', 'password_confirm' => 'password_confirm', 'signature' => 'signature');

	while( list($var, $param) = @each($trim_var_list) )
	{
		if ( !empty($HTTP_POST_VARS[$param]) )
		{
			$$var = trim($HTTP_POST_VARS[$param]);
		}
	}

	$signature = str_replace('<br />', "\n", $signature);
    $gender = ( isset($HTTP_POST_VARS['gender']) ) ? intval ($HTTP_POST_VARS['gender']) : 0;

if (isset($HTTP_POST_VARS['birthday']) ) {
	$birthday = intval ($HTTP_POST_VARS['birthday']);
	$b_day = realdate('j',$birthday); 
	$b_md = realdate('n',$birthday); 
	$b_year = realdate('Y',$birthday);

} else {

	$b_day = ( isset($HTTP_POST_VARS['b_day']) ) ? intval ($HTTP_POST_VARS['b_day']) : 0;
	$b_md = ( isset($HTTP_POST_VARS['b_md']) ) ? intval ($HTTP_POST_VARS['b_md']) : 0;
	$b_year = ( isset($HTTP_POST_VARS['b_year']) ) ? intval ($HTTP_POST_VARS['b_year']) : 0;
	$birthday = mkrealdate($b_day,$b_md,$b_year);
}

	// Run some validation on the optional fields. These are pass-by-ref, so they'll be changed to
	// empty strings if they fail.
	validate_optional_fields($icq, $aim, $msn, $yim, $website, $location, $location2, $occupation, $interests, $signature);

	$viewemail = ( isset($HTTP_POST_VARS['viewemail']) ) ? ( ($HTTP_POST_VARS['viewemail']) ? TRUE : 0 ) : 0;
	$allowviewonline = ( isset($HTTP_POST_VARS['hideonline']) ) ? ( ($HTTP_POST_VARS['hideonline']) ? 0 : TRUE ) : TRUE;
	$notifyreply = ( isset($HTTP_POST_VARS['notifyreply']) ) ? ( ($HTTP_POST_VARS['notifyreply']) ? TRUE : 0 ) : 0;
	$notifypm = ( isset($HTTP_POST_VARS['notifypm']) ) ? ( ($HTTP_POST_VARS['notifypm']) ? TRUE : 0 ) : TRUE;
	$popuppm = ( isset($HTTP_POST_VARS['popup_pm']) ) ? ( ($HTTP_POST_VARS['popup_pm']) ? TRUE : 0 ) : TRUE;
    $occupation = ( isset($HTTP_POST_VARS['occupation']) ) ? intval ($HTTP_POST_VARS['occupation']) : 0;
    $mphone1 = ( isset($HTTP_POST_VARS['mphone1']) ) ? intval ($HTTP_POST_VARS['mphone1']) : 0;
    $hphone1 = ( isset($HTTP_POST_VARS['hphone1']) ) ? intval ($HTTP_POST_VARS['hphone1']) : 0;

    $view_name = ( isset($HTTP_POST_VARS['view_name']) ) ? ( ($HTTP_POST_VARS['view_name']) ? TRUE : 0 ) : 0;
    $view_mphone = ( isset($HTTP_POST_VARS['view_mphone']) ) ? ( ($HTTP_POST_VARS['view_mphone']) ? TRUE : 0 ) : 0;
    $view_hphone = ( isset($HTTP_POST_VARS['view_hphone']) ) ? ( ($HTTP_POST_VARS['view_hphone']) ? TRUE : 0 ) : 0;
    $view_from = ( isset($HTTP_POST_VARS['view_from']) ) ? ( ($HTTP_POST_VARS['view_from']) ? TRUE : 0 ) : 0;
    $view_occ = ( isset($HTTP_POST_VARS['view_occ']) ) ? ( ($HTTP_POST_VARS['view_occ']) ? TRUE : 0 ) : 0;
    $view_photo = ( isset($HTTP_POST_VARS['view_photo']) ) ? ( ($HTTP_POST_VARS['view_photo']) ? TRUE : 0 ) : 0;
    $view_home = ( isset($HTTP_POST_VARS['view_home']) ) ? ( ($HTTP_POST_VARS['view_home']) ? TRUE : 0 ) : 0;
    $view_gender = ( isset($HTTP_POST_VARS['view_gender']) ) ? ( ($HTTP_POST_VARS['view_gender']) ? TRUE : 0 ) : 0;
    $view_birth = ( isset($HTTP_POST_VARS['view_birth']) ) ? ( ($HTTP_POST_VARS['view_birth']) ? TRUE : 0 ) : 0;
    $view_other = ( isset($HTTP_POST_VARS['view_other']) ) ? ( ($HTTP_POST_VARS['view_other']) ? TRUE : 0 ) : 0;

//-----------------------------------------------------------------------------------

	if ( $mode == 'register' )
	{
		$attachsig = ( isset($HTTP_POST_VARS['attachsig']) ) ? ( ($HTTP_POST_VARS['attachsig']) ? TRUE : 0 ) : $board_config['allow_sig'];

		$allowhtml = ( isset($HTTP_POST_VARS['allowhtml']) ) ? ( ($HTTP_POST_VARS['allowhtml']) ? TRUE : 0 ) : $board_config['allow_html'];
		$allowbbcode = ( isset($HTTP_POST_VARS['allowbbcode']) ) ? ( ($HTTP_POST_VARS['allowbbcode']) ? TRUE : 0 ) : $board_config['allow_bbcode'];
		$allowsmilies = ( isset($HTTP_POST_VARS['allowsmilies']) ) ? ( ($HTTP_POST_VARS['allowsmilies']) ? TRUE : 0 ) : $board_config['allow_smilies'];
	}
	else
	{
		$attachsig = ( isset($HTTP_POST_VARS['attachsig']) ) ? ( ($HTTP_POST_VARS['attachsig']) ? TRUE : 0 ) : 0;

		$allowhtml = ( isset($HTTP_POST_VARS['allowhtml']) ) ? ( ($HTTP_POST_VARS['allowhtml']) ? TRUE : 0 ) : $userdata['user_allowhtml'];
		$allowbbcode = ( isset($HTTP_POST_VARS['allowbbcode']) ) ? ( ($HTTP_POST_VARS['allowbbcode']) ? TRUE : 0 ) : $userdata['user_allowbbcode'];
		$allowsmilies = ( isset($HTTP_POST_VARS['allowsmilies']) ) ? ( ($HTTP_POST_VARS['allowsmilies']) ? TRUE : 0 ) : $userdata['user_allowsmile'];
	}

	$user_style = ( isset($HTTP_POST_VARS['style']) ) ? intval($HTTP_POST_VARS['style']) : $board_config['default_style'];

	if ( !empty($HTTP_POST_VARS['language']) )
	{
		if ( preg_match('/^[a-z_]+$/i', $HTTP_POST_VARS['language']) )
		{
			$user_lang = htmlspecialchars($HTTP_POST_VARS['language']);
		}
		else
		{
			$error = true;
			$error_msg = $lang['Fields_empty'];
		}
	}
	else
	{
		$user_lang = $board_config['default_lang'];
	}

	$user_timezone = ( isset($HTTP_POST_VARS['timezone']) ) ? doubleval($HTTP_POST_VARS['timezone']) : $board_config['board_timezone'];
	$user_dateformat = ( !empty($HTTP_POST_VARS['dateformat']) ) ? trim(htmlspecialchars($HTTP_POST_VARS['dateformat'])) : $board_config['default_dateformat'];

	$user_avatar_local = ( isset($HTTP_POST_VARS['avatarselect']) && !empty($HTTP_POST_VARS['submitavatar']) && $board_config['allow_avatar_local'] ) ? $HTTP_POST_VARS['avatarselect'] : ( ( isset($HTTP_POST_VARS['avatarlocal'])  ) ? htmlspecialchars($HTTP_POST_VARS['avatarlocal']) : '' );

	$user_avatar_remoteurl = ( !empty($HTTP_POST_VARS['avatarremoteurl']) ) ? trim(htmlspecialchars($HTTP_POST_VARS['avatarremoteurl'])) : '';
	$user_avatar_upload = ( !empty($HTTP_POST_VARS['avatarurl']) ) ? trim($HTTP_POST_VARS['avatarurl']) : ( ( $HTTP_POST_FILES['avatar']['tmp_name'] != "none") ? $HTTP_POST_FILES['avatar']['tmp_name'] : '' );
	$user_avatar_name = ( !empty($HTTP_POST_FILES['avatar']['name']) ) ? $HTTP_POST_FILES['avatar']['name'] : '';
	$user_avatar_size = ( !empty($HTTP_POST_FILES['avatar']['size']) ) ? $HTTP_POST_FILES['avatar']['size'] : 0;
	$user_avatar_filetype = ( !empty($HTTP_POST_FILES['avatar']['type']) ) ? $HTTP_POST_FILES['avatar']['type'] : '';

	$user_avatar = ( empty($user_avatar_loc) && $mode == 'editprofile' ) ? $userdata['user_avatar'] : '';
	$user_avatar_type = ( empty($user_avatar_loc) && $mode == 'editprofile' ) ? $userdata['user_avatar_type'] : '';

	if ( (isset($HTTP_POST_VARS['avatargallery']) || isset($HTTP_POST_VARS['submitavatar']) || isset($HTTP_POST_VARS['cancelavatar'])) && (!isset($HTTP_POST_VARS['submit'])) )
	{
		$username = stripslashes($username);
		$email = stripslashes($email);
		$cur_password = htmlspecialchars(stripslashes($cur_password));
		$new_password = htmlspecialchars(stripslashes($new_password));
		$password_confirm = htmlspecialchars(stripslashes($password_confirm));

		$icq = stripslashes($icq);
		$aim = stripslashes($aim);
		$msn = stripslashes($msn);
		$yim = stripslashes($yim);

		$website = stripslashes($website);
		$location = stripslashes($location);
		$location2 = stripslashes($location2);
		$occupation = stripslashes($occupation);
		$interests = stripslashes($interests);
		$signature = stripslashes($signature);
		$user_lang = stripslashes($user_lang);
		$user_dateformat = stripslashes($user_dateformat);

		if ( !isset($HTTP_POST_VARS['cancelavatar']))
		{
			$user_avatar = $user_avatar_local;
			$user_avatar_type = USER_AVATAR_GALLERY;
		}
	}
}
//
// Let's make sure the user isn't logged in while registering,
// and ensure that they were trying to register a second time
// (Prevents double registrations)
//
if ( $userdata['session_logged_in'] && $mode =="register" && $username == $userdata['username'])
{
	message_die(GENERAL_MESSAGE, $lang['Username_taken'], '', __LINE__, __FILE__);
}

//
// Did the user submit? In this case build a query to update the users profile in the DB
//

//----------------------------------------------------------------------------------
//  ʵ带  ø ϱ Լ....
//----------------------------------------------------------------------------------

user_field($board_config['use_realname'],'switch_use_realname','switch_realname_req');
user_field($board_config['use_jumin'],'switch_use_jumin','switch_jumin_req');
user_field($board_config['use_mphone'],'switch_use_mphone','switch_mphone_req');
user_field($board_config['use_hphone'],'switch_use_hphone','switch_hphone_req');
user_field($board_config['use_occ'],'switch_use_occ','switch_occ_req');
user_field($board_config['use_from'],'switch_use_from','switch_from_req');
user_field($board_config['use_birth'],'switch_use_birth','switch_birth_req');
user_field($board_config['use_gender'],'switch_use_gender','switch_gender_req');

/**********************************************************************************/

if ( isset($HTTP_POST_VARS['submit']) )
{
	include($phpbb_root_path . 'includes/usercp_avatar.'.$phpEx);

	$passwd_sql = '';
	if ( $mode == 'editprofile' )
	{
		if ( $user_id != $userdata['user_id'] )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Wrong_Profile'];
		}
	}
	else if ( $mode == 'register' )
	{
  
       $mphone = addslashes($mphone1.'-'.$mphone2.'-'.$mphone3);
       $hphone = addslashes($hphone1.'-'.$hphone2.'-'.$hphone3);
       $location = addslashes($location . "/" . $location2);
       $zipcode = addslashes(trim($zipcode1 . '-' . $zipcode2));
       //----------------------------------------------------
       // üũԼ ȣ.` -_-;
       //----------------------------------------------------
        Check_Form();

		if ( empty($username) || empty($new_password) || empty($password_confirm) || empty($email) )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Fields_empty'];
		}
	}

	$passwd_sql = '';
	if ( !empty($new_password) && !empty($password_confirm) )
	{
		if ( $new_password != $password_confirm )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Password_mismatch'];
		}
		else if ( strlen($new_password) > 32 )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Password_long'];
		}
		else
		{
			if ( $mode == 'editprofile' )
			{
				$sql = "SELECT user_password
					FROM " . USERS_TABLE . "
					WHERE user_id = $user_id";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not obtain user_password information', '', __LINE__, __FILE__, $sql);
				}

				$row = $db->sql_fetchrow($result);

				if ( $row['user_password'] != md5($cur_password) )
				{
					$error = TRUE;
					$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Current_password_mismatch'];
				}
			}

			if ( !$error )
			{
				$new_password = md5($new_password);
				$passwd_sql = "user_password = '$new_password', ";
			}
		}
	}
	else if ( ( empty($new_password) && !empty($password_confirm) ) || ( !empty($new_password) && empty($password_confirm) ) )
	{
		$error = TRUE;
		$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Password_mismatch'];
	}

	//
	// Do a ban check on this email address
	//
	if ( $email != $userdata['user_email'] || $mode == 'register' )
	{
		$result = validate_email($email);
		if ( $result['error'] )
		{
			$email = $userdata['user_email'];

			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $result['error_msg'];
		}

		if ( $mode == 'editprofile' )
		{
			$sql = "SELECT user_password
				FROM " . USERS_TABLE . "
				WHERE user_id = $user_id";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain user_password information', '', __LINE__, __FILE__, $sql);
			}

			$row = $db->sql_fetchrow($result);

			if ( $row['user_password'] != md5($cur_password) )
			{
				$email = $userdata['user_email'];

				$error = TRUE;
				$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Current_password_mismatch'];
			}
		}
	}

	$username_sql = '';
	if ( $board_config['allow_namechange'] || $mode == 'register' )
	{
		if ( empty($username) )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Username_disallowed'];
		}
		else if ( $username != $userdata['username'] || $mode == 'register' )
		{
			if (strtolower($username) != strtolower($userdata['username']))
			{
				$result = validate_username($username);
				if ( $result['error'] )
				{
					$error = TRUE;
					$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $result['error_msg'];
				}
			}

			if (!$error)
			{
				$username_sql = "username = '" . str_replace("\'", "''", $username) . "', ";
			}
		}
	}

	if ( $signature != '' )
	{
		if ( strlen($signature) > $board_config['max_sig_chars'] )
		{
			$error = TRUE;
			$error_msg .= ( ( isset($error_msg) ) ? '<br />' : '' ) . $lang['Signature_too_long'];
		}

		if ( $signature_bbcode_uid == '' )
		{
			$signature_bbcode_uid = ( $allowbbcode ) ? make_bbcode_uid() : '';
		}
		$signature = prepare_message($signature, $allowhtml, $allowbbcode, $allowsmilies, $signature_bbcode_uid);
	}

	//??
	if ( $website != '' )
	{
		rawurlencode($website);
	}

	$avatar_sql = '';

	if ( isset($HTTP_POST_VARS['avatardel']) && $mode == 'editprofile' )
	{
		$avatar_sql = user_avatar_delete($userdata['user_avatar_type'], $userdata['user_avatar']);
	}

	if ( ( !empty($user_avatar_upload) || !empty($user_avatar_name) ) && $board_config['allow_avatar_upload'] )
	{
		if ( !empty($user_avatar_upload) )
		{
			$avatar_mode = ( !empty($user_avatar_name) ) ? 'local' : 'remote';
			$avatar_sql = user_avatar_upload($mode, $avatar_mode, $userdata['user_avatar'], $userdata['user_avatar_type'], $error, $error_msg, $user_avatar_upload, $user_avatar_name, $user_avatar_size, $user_avatar_filetype);
		}
		else if ( !empty($user_avatar_name) )
		{
			$l_avatar_size = sprintf($lang['Avatar_filesize'], round($board_config['avatar_filesize'] / 1024));

			$error = true;
			$error_msg .= ( ( !empty($error_msg) ) ? '<br />' : '' ) . $l_avatar_size;
		}
	}
	else if ( $user_avatar_remoteurl != '' && $board_config['allow_avatar_remote'] )
	{
		if ( @file_exists(@phpbb_realpath('./' . $board_config['avatar_path'] . '/' . $userdata['user_avatar'])) )
		{
			@unlink(@phpbb_realpath('./' . $board_config['avatar_path'] . '/' . $userdata['user_avatar']));
		}
		$avatar_sql = user_avatar_url($mode, $error, $error_msg, $user_avatar_remoteurl);
	}
	else if ( $user_avatar_local != '' && $board_config['allow_avatar_local'] )
	{
		if ( @file_exists(@phpbb_realpath('./' . $board_config['avatar_path'] . '/' . $userdata['user_avatar'])) )
		{
			@unlink(@phpbb_realpath('./' . $board_config['avatar_path'] . '/' . $userdata['user_avatar']));
		}
		$avatar_sql = user_avatar_gallery($mode, $error, $error_msg, $user_avatar_local);

// find the birthday values, reflected by the $lang['Submit_date_format'] 
if ($b_day || $b_md || $b_year) //if a birthday is submited, then validate it 
{ 
      $user_age=(date('md')>=$b_md.(($b_day <= 9) ? '0':'').$b_day) ? date('Y') - $b_year : date('Y') - $b_year - 1 ; 
      // Check date, maximum / minimum user age 
      if (!checkdate($b_md,$b_day,$b_year)) 
      { 
         $error = TRUE; 
         if( isset($error_msg) )$error_msg .= "<br />"; 
         $error_msg .= $lang['Wrong_birthday_format']; 
      } else
	if ($user_age>$board_config['max_user_age'])
	{
         $error = TRUE; 
         if( isset($error_msg) )$error_msg .= "<br />"; 
         $error_msg .= sprintf($lang['Birthday_to_high'],$board_config['max_user_age']); 
	} else 
	if ($user_age<$board_config['min_user_age'])
	{
         $error = TRUE; 
         if( isset($error_msg) )$error_msg .= "<br />"; 
         $error_msg .= sprintf($lang['Birthday_to_low'],$board_config['min_user_age']); 
	} else 
      { 
         $birthday = ($error) ? $birthday : mkrealdate($b_day,$b_md,$b_year);
         $next_birthday_greeting = (date('md')<$b_md.(($b_day <= 9) ? '0':'').$b_day) ? date('Y'):date('Y')+1 ; 
      } 
}
	}

	if ( !$error )
	{
		if ( $avatar_sql == '' )
		{
			$avatar_sql = ( $mode == 'editprofile' ) ? '' : "'', " . USER_AVATAR_NONE;
		}

		if ( $mode == 'editprofile' )
		{
			if ( $email != $userdata['user_email'] && $board_config['require_activation'] != USER_ACTIVATION_NONE && $userdata['user_level'] != ADMIN )
			{
				$user_active = 0;

				$user_actkey = gen_rand_string(true);
				$key_len = 54 - ( strlen($server_url) );
				$key_len = ( $key_len > 6 ) ? $key_len : 6;
				$user_actkey = substr($user_actkey, 0, $key_len);

				if ( $userdata['session_logged_in'] )
				{
					session_end($userdata['session_id'], $userdata['user_id']);
				}
			}
			else
			{
				$user_active = 1;
				$user_actkey = '';
			}

        $mphone = addslashes($mphone1.'-'.$mphone2.'-'.$mphone3);
        $hphone = addslashes($hphone1.'-'.$hphone2.'-'.$hphone3);
        $location = addslashes($location . "/" . $location2);
        $zipcode = addslashes(trim($zipcode1 . '-' . $zipcode2));
        
       //----------------------------------------------------
       // üũԼ ȣ.` -_-;
       //----------------------------------------------------
        Check_Form();

			$sql = "UPDATE " . USERS_TABLE . "
				SET " . $username_sql . $passwd_sql . "user_email = '" . str_replace("\'", "''", $email) ."', user_icq = '" . str_replace("\'", "''", $icq) . "', user_website = '" . str_replace("\'", "''", $website) . "', user_occ = '$occupation', user_from = '" . str_replace("\'", "''", $location) . "', user_interests = '" . str_replace("\'", "''", $interests) . "', user_birthday='$birthday', user_sig = '" . str_replace("\'", "''", $signature) . "', user_sig_bbcode_uid = '$signature_bbcode_uid', user_viewemail = $viewemail, user_aim = '" . str_replace("\'", "''", str_replace(' ', '+', $aim)) . "', user_yim = '" . str_replace("\'", "''", $yim) . "', user_msnm = '" . str_replace("\'", "''", $msn) . "', user_attachsig = $attachsig, user_allowsmile = $allowsmilies, user_allowhtml = $allowhtml, user_allowbbcode = $allowbbcode, user_allow_viewonline = $allowviewonline, user_notify = $notifyreply, user_notify_pm = $notifypm, user_popup_pm = $popuppm, user_timezone = $user_timezone, user_dateformat = '" . str_replace("\'", "''", $user_dateformat) . "', user_lang = '" . str_replace("\'", "''", $user_lang) . "', user_style = $user_style, user_active = $user_active, user_actkey = '" . str_replace("\'", "''", $user_actkey) . "'" . $avatar_sql . ", user_gender=$gender, user_realname = '" . str_replace("\'", "''", $realname) . "', user_zipcode = '$zipcode', user_jumin1 = '$jumin1', user_jumin2 = '$jumin2', user_mphone = '$mphone', user_hphone = '$hphone', user_view_name = $view_name, user_view_mphone = $view_mphone, user_view_hphone = $view_hphone, user_view_from = $view_from, user_view_occ = $view_occ, user_view_photo = $view_photo, user_view_home = $view_home, user_view_gender = $view_gender, user_view_birth = $view_birth, user_view_other = $view_other
				WHERE user_id = $user_id";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
			}

			if ( !$user_active )
			{
				//
				// The users account has been deactivated, send them an email with a new activation key
				//
				include($phpbb_root_path . 'includes/emailer.'.$phpEx);
				$emailer = new emailer($board_config['smtp_delivery']);

				$email_headers = "From: " . $board_config['board_email'] . "\nReturn-Path: " . $board_config['board_email'] . "\n";

				$emailer->use_template('user_activate', stripslashes($user_lang));
				$emailer->email_address($email);
				$emailer->set_subject($lang['Reactivate']);
				$emailer->extra_headers($email_headers);

				$emailer->assign_vars(array(
					'SITENAME' => $board_config['sitename'],
					'USERNAME' => $username,
					'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '',

					'U_ACTIVATE' => $server_url . '?mode=activate&' . POST_USERS_URL . '=' . $user_id . '&act_key=' . $user_actkey)
				);
				$emailer->send();
				$emailer->reset();

				$message = $lang['Profile_updated_inactive'] . '<br /><br />' . sprintf($lang['Click_return_index'],  '<a href="' . append_sid("index.$phpEx") . '">', '</a>');
			}
			else
			{
				$message = $lang['Profile_updated'] . '<br /><br />' . sprintf($lang['Click_return_index'],  '<a href="' . append_sid("index.$phpEx") . '">', '</a>');
			}

			$template->assign_vars(array(
				"META" => '<meta http-equiv="refresh" content="5;url=' . append_sid("index.$phpEx") . '">')
			);

			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			$sql = "SELECT MAX(user_id) AS total
				FROM " . USERS_TABLE;
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain next user_id information', '', __LINE__, __FILE__, $sql);
			}

			if ( !($row = $db->sql_fetchrow($result)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain next user_id information', '', __LINE__, __FILE__, $sql);
			}
			$user_id = $row['total'] + 1;

			//
			// Get current date
			//

			$sql = "INSERT INTO " . USERS_TABLE . "	(user_id, username, user_regdate, user_password, user_email, user_icq, user_website, user_occ, user_from, user_interests, user_sig, user_sig_bbcode_uid, user_avatar, user_avatar_type, user_viewemail, user_aim, user_yim, user_msnm, user_attachsig, user_allowsmile, user_allowhtml, user_allowbbcode, user_allow_viewonline, user_notify, user_notify_pm, user_popup_pm, user_timezone, user_dateformat, user_lang, user_style, user_level, user_allow_pm, user_gender, user_birthday, user_next_birthday_greeting, user_realname, user_zipcode, user_jumin1, user_jumin2, user_mphone, user_hphone, user_view_name, user_view_mphone, user_view_hphone, user_view_from, user_view_occ, user_view_photo, user_view_home, user_view_gender, user_view_birth, user_view_other, user_active, user_actkey)
				VALUES ($user_id, '" . str_replace("\'", "''", $username) . "', " . time() . ", '" . str_replace("\'", "''", $new_password) . "', '" . str_replace("\'", "''", $email) . "', '" . str_replace("\'", "''", $icq) . "', '" . str_replace("\'", "''", $website) . "', $occupation, '" . str_replace("\'", "''", $location) . "', '" . str_replace("\'", "''", $interests) . "', '" . str_replace("\'", "''", $signature) . "', '$signature_bbcode_uid', $avatar_sql, $viewemail, '" . str_replace("\'", "''", str_replace(' ', '+', $aim)) . "', '" . str_replace("\'", "''", $yim) . "', '" . str_replace("\'", "''", $msn) . "', $attachsig, $allowsmilies, $allowhtml, $allowbbcode, $allowviewonline, $notifyreply, $notifypm, $popuppm, $user_timezone, '" . str_replace("\'", "''", $user_dateformat) . "', '" . str_replace("\'", "''", $user_lang) . "', $user_style, 0, 1, '$gender', '$birthday','$next_birthday_greeting', '$realname', '$zipcode', '$jumin1', '$jumin2', '$mphone', '$hphone', $view_name, $view_mphone, $view_hphone, $view_from, $view_occ, $view_photo, $view_home, $view_gender, $view_birth, $view_other,";
			if ( $board_config['require_activation'] == USER_ACTIVATION_SELF || $board_config['require_activation'] == USER_ACTIVATION_ADMIN || $coppa )
			{
				$user_actkey = gen_rand_string(true);
				$key_len = 54 - (strlen($server_url));
				$key_len = ( $key_len > 6 ) ? $key_len : 6;
				$user_actkey = substr($user_actkey, 0, $key_len);
				$sql .= "0, '" . str_replace("\'", "''", $user_actkey) . "')";
			}
			else
			{
				$sql .= "1, '')";
			}

			if ( !($result = $db->sql_query($sql, BEGIN_TRANSACTION)) )
			{
				message_die(GENERAL_ERROR, 'Could not insert data into users table', '', __LINE__, __FILE__, $sql);
			}

    // START - SEND PM ON REGISTER MOD - AbelaJohnB
	//
	// According to 'netclectic' we need to set the datastamp to '9999999999' in order to
	// insure the pop-up notification about a new message existing. I concur with 'netclectic'
	// and have thus made the change to his suggestion. Thanks netclectic!
        //
	    $sql = "UPDATE " . USERS_TABLE . " 
		SET user_new_privmsg = '1', user_last_privmsg = '9999999999'
				WHERE user_id = $user_id";
		if ( !($result = $db->sql_query($sql)) )
        {
		    message_die(GENERAL_ERROR, 'Could not update users table', '', __LINE__, __FILE__, $sql);
        }

        $register_pm_subject = $lang['register_pm_subject'];
        $register_pm = $lang['register_pm'];
        $privmsgs_date = date("U");
        $sql = "INSERT INTO " . PRIVMSGS_TABLE . " (privmsgs_type, privmsgs_subject, privmsgs_from_userid, privmsgs_to_userid, privmsgs_date, privmsgs_enable_html, privmsgs_enable_bbcode, privmsgs_enable_smilies, privmsgs_attach_sig) VALUES ('0', '" . str_replace("\'", "''", addslashes(sprintf($register_pm_subject,$board_config['sitename']))) . "', '2', " . $user_id . ", " . $privmsgs_date . ", '0', '1', '1', '0')";
        if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not insert private message sent info', '', __LINE__, __FILE__, $sql);
		}

		$privmsg_sent_id = $db->sql_nextid();
		$privmsgs_text = $lang['register_pm_subject'];
        //
        $sql = "INSERT INTO " . PRIVMSGS_TEXT_TABLE . " (privmsgs_text_id, privmsgs_text) VALUES ($privmsg_sent_id, '" . str_replace("\'", "''", addslashes(sprintf($register_pm,$board_config['sitename'],$board_config['sitename']))) . "')";
        if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not insert private message sent text', '', __LINE__, __FILE__, $sql);
		}
        // END - SEND PM ON REGISTER MOD - AbelaJohnB

			$sql = "INSERT INTO " . GROUPS_TABLE . " (group_name, group_description, group_single_user, group_moderator)
				VALUES ('', 'Personal User', 1, 0)";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not insert data into groups table', '', __LINE__, __FILE__, $sql);
			}

			$group_id = $db->sql_nextid();

			$sql = "INSERT INTO " . USER_GROUP_TABLE . " (user_id, group_id, user_pending)
				VALUES ($user_id, $group_id, 0)";
			if( !($result = $db->sql_query($sql, END_TRANSACTION)) )
			{
				message_die(GENERAL_ERROR, 'Could not insert data into user_group table', '', __LINE__, __FILE__, $sql);
			}

			if ( $coppa )
			{
				$message = $lang['COPPA'];
				$email_template = 'coppa_welcome_inactive';
			}
			else if ( $board_config['require_activation'] == USER_ACTIVATION_SELF )
			{
				$message = $lang['Account_inactive'];
				$email_template = 'user_welcome_inactive';
			}
			else if ( $board_config['require_activation'] == USER_ACTIVATION_ADMIN )
			{
				$message = $lang['Account_inactive_admin'];
				$email_template = 'admin_welcome_inactive';
			}
			else
			{
				$message = $lang['Account_added'];
				$email_template = 'user_welcome';
			}

			include($phpbb_root_path . 'includes/emailer.'.$phpEx);
			$emailer = new emailer($board_config['smtp_delivery']);

			$email_headers = "From: " . $board_config['board_email'] . "\nReturn-Path: " . $board_config['board_email'] . "\n";

			$emailer->use_template($email_template, stripslashes($user_lang));
			$emailer->email_address($email);
			$emailer->set_subject(sprintf($lang['Welcome_subject'], $board_config['sitename']));
			$emailer->extra_headers($email_headers);

			if( $coppa )
			{
				$emailer->assign_vars(array(
					'SITENAME' => $board_config['sitename'],
					'WELCOME_MSG' => sprintf($lang['Welcome_subject'], $board_config['sitename']),
					'USERNAME' => $username,
					'PASSWORD' => $password_confirm,
					'EMAIL_SIG' => str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']),

					'FAX_INFO' => $board_config['coppa_fax'],
					'MAIL_INFO' => $board_config['coppa_mail'],
					'EMAIL_ADDRESS' => $email,
					'ICQ' => $icq,
					'AIM' => $aim,
					'YIM' => $yim,
					'MSN' => $msn,
					'WEB_SITE' => $website,
					'FROM' => $location,
					'OCC' => $occupation,
					'INTERESTS' => $interests,
					'SITENAME' => $board_config['sitename']));
			}
			else
			{
				$emailer->assign_vars(array(
					'SITENAME' => $board_config['sitename'],
					'WELCOME_MSG' => sprintf($lang['Welcome_subject'], $board_config['sitename']),
					'USERNAME' => $username,
					'PASSWORD' => $password_confirm,
					'EMAIL_SIG' => str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']),

					'U_ACTIVATE' => $server_url . '?mode=activate&' . POST_USERS_URL . '=' . $user_id . '&act_key=' . $user_actkey)
				);
			}

			$emailer->send();
			$emailer->reset();

			if ( $board_config['require_activation'] == USER_ACTIVATION_ADMIN )
			{
				//$emailer->use_template("admin_activate", stripslashes($user_lang));
				$emailer->use_template("admin_activate", $board_config['default_lang']);
				$emailer->email_address($board_config['board_email']);
				$emailer->set_subject($lang['New_account_subject']);
				$emailer->extra_headers($email_headers);

				$emailer->assign_vars(array(
					'USERNAME' => $username,
					'EMAIL_SIG' => str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']),

					'U_ACTIVATE' => $server_url . '?mode=activate&' . POST_USERS_URL . '=' . $user_id . '&act_key=' . $user_actkey)
				);
				$emailer->send();
				$emailer->reset();
			}

			$message = $message . '<br /><br />' . sprintf($lang['Click_return_index'],  '<a href="' . append_sid("index.$phpEx") . '">', '</a>');

			message_die(GENERAL_MESSAGE, $message);
		} // if mode == register
	}
} // End of submit


if ( $error )
{
	//
	// If an error occured we need to stripslashes on returned data
	//
	$username = stripslashes($username);
	$email = stripslashes($email);
	$new_password = '';
	$password_confirm = '';

	$icq = stripslashes($icq);
	$aim = str_replace('+', ' ', stripslashes($aim));
	$msn = stripslashes($msn);
	$yim = stripslashes($yim);

	$website = stripslashes($website);
	$location = stripslashes($location);
	$location2 = stripslashes($location2);

/***********************************************************************************/

	$occupation = stripslashes($occupation);
	$interests = stripslashes($interests);
	$signature = stripslashes($signature);
	$signature = ($signature_bbcode_uid != '') ? preg_replace("/:(([a-z0-9]+:)?)$signature_bbcode_uid\]/si", ']', $signature) : $signature;

	$user_lang = stripslashes($user_lang);
	$user_dateformat = stripslashes($user_dateformat);

}
else if ( $mode == 'editprofile' && !isset($HTTP_POST_VARS['avatargallery']) && !isset($HTTP_POST_VARS['submitavatar']) && !isset($HTTP_POST_VARS['cancelavatar']) )
{
	$user_id = $userdata['user_id'];
	$username = $userdata['username'];
	$email = $userdata['user_email'];
	$new_password = '';
	$password_confirm = '';

	$icq = $userdata['user_icq'];
	$aim = str_replace('+', ' ', $userdata['user_aim']);
	$msn = $userdata['user_msnm'];
	$yim = $userdata['user_yim'];

	$website = $userdata['user_website'];
    $from_ary = explode('/', $userdata['user_from']);
	$location = $from_ary[0];
	$location2 = $from_ary[1];
	$interests = $userdata['user_interests'];
    $gender = $userdata['user_gender'];
	$signature_bbcode_uid = $userdata['user_sig_bbcode_uid'];
	$signature = ($signature_bbcode_uid != '') ? preg_replace("/:(([a-z0-9]+:)?)$signature_bbcode_uid\]/si", ']', $userdata['user_sig']) : $userdata['user_sig'];

if ($userdata['user_birthday']!=999999) {
	$birthday = realdate($lang['Submit_date_format'],$userdata['user_birthday']); 
	$b_day = realdate('j',$userdata['user_birthday']); 
	$b_md = realdate('n',$userdata['user_birthday']); 
	$b_year = realdate('Y',$userdata['user_birthday']); 

} else {

	$b_day = ''; 
	$b_md = ''; 
	$b_year = ''; 
	$birthday = ''; 
}
	$realname = $userdata['user_realname'];
	$occupation = $userdata['user_occ'];

    $jumin1 = $userdata['user_jumin1'];
    $jumin2 = $userdata['user_jumin2'];

    $zipcode_ary = explode("-", $userdata['user_zipcode']);
    $zipcode1 = $zipcode_ary[0];
    $zipcode2 = $zipcode_ary[1];

    $mphone_ary = explode("-", $userdata['user_mphone']);
    $mphone1 = $mphone_ary[0];
    $mphone2 = $mphone_ary[1];
    $mphone3 = $mphone_ary[2];

    $hphone_ary = explode("-", $userdata['user_hphone']);
    $hphone1 = $hphone_ary[0];
    $hphone2 = $hphone_ary[1];
    $hphone3 = $hphone_ary[2];

// Check Variable 
    $view_name = $userdata['user_view_name'];
    $view_mphone = $userdata['user_view_mphone'];
    $view_hphone = $userdata['user_view_hphone'];
    $view_from = $userdata['user_view_from'];
    $view_occ = $userdata['user_view_occ'];
    $view_photo = $userdata['user_view_photo'];
    $view_home = $userdata['user_view_home'];
    $view_gender = $userdata['user_view_gender'];
    $view_birth = $userdata['user_view_birth'];
    $view_other = $userdata['user_view_other'];

/***********************************************************************************/

	$viewemail = $userdata['user_viewemail'];
	$notifypm = $userdata['user_notify_pm'];
	$popuppm = $userdata['user_popup_pm'];
	$notifyreply = $userdata['user_notify'];
	$notifydonation = $userdata['user_notify_donation'];
	$attachsig = $userdata['user_attachsig'];
	$allowhtml = $userdata['user_allowhtml'];
	$allowbbcode = $userdata['user_allowbbcode'];
	$allowsmilies = $userdata['user_allowsmile'];
	$allowviewonline = $userdata['user_allow_viewonline'];
	$user_avatar = ( $userdata['user_allowavatar'] ) ? $userdata['user_avatar'] : '';
	$user_avatar_type = ( $userdata['user_allowavatar'] ) ? $userdata['user_avatar_type'] : USER_AVATAR_NONE;
	$user_style = $userdata['user_style'];
	$user_lang = $userdata['user_lang'];
	$user_timezone = $userdata['user_timezone'];
	$user_dateformat = $userdata['user_dateformat'];
}

//
// Default pages
//
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

make_jumpbox('viewforum.'.$phpEx);

if ( $mode == 'editprofile' )
{
	if ( $user_id != $userdata['user_id'] )
	{
		$error = TRUE;
		$error_msg = $lang['Wrong_Profile'];
	}
}

if( isset($HTTP_POST_VARS['avatargallery']) && !$error )
{
	include($phpbb_root_path . 'includes/usercp_avatar.'.$phpEx);

	$avatar_category = ( !empty($HTTP_POST_VARS['avatarcategory']) ) ? $HTTP_POST_VARS['avatarcategory'] : '';

	$template->set_filenames(array(
		'body' => 'profile_avatar_gallery.tpl')
	);

	$allowviewonline = !$allowviewonline;

	display_avatar_gallery($mode, $avatar_category, $user_id, $email, $current_email, $coppa, $username, $email, &$new_password, &$cur_password, $password_confirm, $icq, $aim, $msn, $yim, $website, $location, $location2, $occupation, $interests, $signature, $viewemail, $notifypm, $popuppm, $notifyreply, $attachsig, $allowhtml, $allowbbcode, $allowsmilies, $allowviewonline, $user_style, $user_lang, $user_timezone, $user_dateformat, $userdata['session_id'], $gender, $birthday, $realname, $zipcode1, $zipcode2, $jumin1, $jumin2, $mphone1, $mphone2, $mphone3, $hphone1, $hphone2, $hphone3, $view_name, $view_mphone, $view_hphone, $view_from, $view_occ, $view_photo, $view_home, $view_gender, $view_birth, $view_other);
}
else
{
	include($phpbb_root_path . 'includes/functions_selects.'.$phpEx);

	if ( !isset($coppa) )
	{
		$coppa = FALSE;
	}

	if ( !isset($user_template) )
	{
		$selected_template = $board_config['system_template'];
	}

	$avatar_img = '';
	if ( $user_avatar_type )
	{
		switch( $user_avatar_type )
		{
			case USER_AVATAR_UPLOAD:
				$avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $user_avatar . '" alt="" />' : '';
				break;
			case USER_AVATAR_REMOTE:
				$avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $user_avatar . '" alt="" />' : '';
				break;
			case USER_AVATAR_GALLERY:
				$avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $user_avatar . '" alt="" />' : '';
				break;
		}
	}

	$s_hidden_fields = '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" /><input type="hidden" name="mode" value="' . $mode . '" /><input type="hidden" name="agreed" value="true" /><input type="hidden" name="coppa" value="' . $coppa . '" />';
	if( $mode == 'editprofile' )
	{
		$s_hidden_fields .= '<input type="hidden" name="user_id" value="' . $userdata['user_id'] . '" />';
		//
		// Send the users current email address. If they change it, and account activation is turned on
		// the user account will be disabled and the user will have to reactivate their account.
		//
		$s_hidden_fields .= '<input type="hidden" name="current_email" value="' . $userdata['user_email'] . '" />';
	}

	if ( !empty($user_avatar_local) )
	{
		$s_hidden_fields .= '<input type="hidden" name="avatarlocal" value="' . $user_avatar_local . '" />';
	}

	$html_status =  ( $userdata['user_allowhtml'] && $board_config['allow_html'] ) ? $lang['HTML_is_ON'] : $lang['HTML_is_OFF'];
	$bbcode_status = ( $userdata['user_allowbbcode'] && $board_config['allow_bbcode']  ) ? $lang['BBCode_is_ON'] : $lang['BBCode_is_OFF'];
	$smilies_status = ( $userdata['user_allowsmile'] && $board_config['allow_smilies']  ) ? $lang['Smilies_are_ON'] : $lang['Smilies_are_OFF'];

    switch ($gender) { 
       case 1: $gender_male_checked="checked=\"checked\"";break; 
       case 2: $gender_female_checked="checked=\"checked\"";break; 
      default:$gender_no_specify_checked="checked=\"checked\""; 
    } 

	if ( $error )
	{
		$template->set_filenames(array(
			'reg_header' => 'error_body.tpl')
		);
		$template->assign_vars(array(
            'ERROR_IMG'  => $images['error'],
			'ERROR_MESSAGE' => $error_msg)
		);
		$template->assign_var_from_handle('ERROR_BOX', 'reg_header');
	}
    /*  ø
	$template->set_filenames(array(
		'body' => 'profile_add_body.tpl')
	);*/

    if ($mode=='register') 
        $template->set_filenames(array(   
           'body' => 'profile_register_body.tpl')
        ); 
    else $template->set_filenames(array(
           'body' => 'profile_add_body.tpl')
        );


	if ($mode == 'editprofile' ) {
		$template->assign_block_vars('switch_edit_profile', array());
	}

$s_b_day = '&nbsp;<select name="b_day" size="1" class="gensmall" size="1">
	<option value="0">&nbsp;-&nbsp;</option>
	<option value="1">&nbsp;1&nbsp;</option>
	<option value="2">&nbsp;2&nbsp;</option>
	<option value="3">&nbsp;3&nbsp;</option>
	<option value="4">&nbsp;4&nbsp;</option>
	<option value="5">&nbsp;5&nbsp;</option>
	<option value="6">&nbsp;6&nbsp;</option>
	<option value="7">&nbsp;7&nbsp;</option>
	<option value="8">&nbsp;8&nbsp;</option>
	<option value="9">&nbsp;9&nbsp;</option>
	<option value="10">&nbsp;10&nbsp;</option>
	<option value="11">&nbsp;11&nbsp;</option>
	<option value="12">&nbsp;12&nbsp;</option>
	<option value="13">&nbsp;13&nbsp;</option>
	<option value="14">&nbsp;14&nbsp;</option>
	<option value="15">&nbsp;15&nbsp;</option>
	<option value="16">&nbsp;16&nbsp;</option>
	<option value="17">&nbsp;17&nbsp;</option>
	<option value="18">&nbsp;18&nbsp;</option>
	<option value="19">&nbsp;19&nbsp;</option>
	<option value="20">&nbsp;20&nbsp;</option>
	<option value="21">&nbsp;21&nbsp;</option>
	<option value="22">&nbsp;22&nbsp;</option>
	<option value="23">&nbsp;23&nbsp;</option>
	<option value="24">&nbsp;24&nbsp;</option>
	<option value="25">&nbsp;25&nbsp;</option>
	<option value="26">&nbsp;26&nbsp;</option>
	<option value="27">&nbsp;27&nbsp;</option>
	<option value="28">&nbsp;28&nbsp;</option>
	<option value="29">&nbsp;29&nbsp;</option>
	<option value="30">&nbsp;30&nbsp;</option>
	<option value="31">&nbsp;31&nbsp;</option>
  	</select>&nbsp;'.$lang['Day'].' &nbsp; ' ;
$s_b_md = '&nbsp;<select name="b_md" size="1" class="gensmall" size="1"}"> 
    <option value="0">&nbsp;-&nbsp;</option> 
    <option value="1">&nbsp;'.$lang['datetime']['January'].'&nbsp;</option> 
    <option value="2">&nbsp;'.$lang['datetime']['February'].'&nbsp;</option> 
    <option value="3">&nbsp;'.$lang['datetime']['March'].'&nbsp;</option> 
    <option value="4">&nbsp;'.$lang['datetime']['April'].'&nbsp;</option> 
    <option value="5">&nbsp;'.$lang['datetime']['May'].'&nbsp;</option> 
    <option value="6">&nbsp;'.$lang['datetime']['June'].'&nbsp;</option> 
    <option value="7">&nbsp;'.$lang['datetime']['July'].'&nbsp;</option> 
    <option value="8">&nbsp;'.$lang['datetime']['August'].'&nbsp;</option> 
    <option value="9">&nbsp;'.$lang['datetime']['September'].'&nbsp;</option> 
    <option value="10">&nbsp;'.$lang['datetime']['October'].'&nbsp;</option> 
    <option value="11">&nbsp;'.$lang['datetime']['November'].'&nbsp;</option> 
    <option value="12">&nbsp;'.$lang['datetime']['December'].'&nbsp;</option> 
    </select>&nbsp;'.$lang['Month'].' &nbsp; '; 

$s_b_day= str_replace("value=\"".$b_day."\">", "value=\"".$b_day."\" SELECTED>" ,$s_b_day);
$s_b_md = str_replace("value=\"".$b_md."\">", "value=\"".$b_md."\" SELECTED>" ,$s_b_md);
$s_b_year = '<input type="text" class="post"style="width: 40px"  name="b_year" size="4" maxlength="4" value="'.$b_year.'" />'.'&nbsp;'.$lang['Year'].'&nbsp;';
$i=0;
$s_birthday='';

for ($i=0;$i<=strlen($lang['Submit_date_format']);$i++)  { 

	switch ($lang['Submit_date_format'][$i]) { 
       	case d:  $s_birthday .=$s_b_day;break; 
        	case m:  $s_birthday .=$s_b_md;break; 
      	case Y:  $s_birthday .=$s_b_year;break; 
   }
}
	//
	// Let's do an overall check for settings/versions which would prevent
	// us from doing file uploads....
	//
	$ini_val = ( phpversion() >= '4.0.0' ) ? 'ini_get' : 'get_cfg_var';
	$form_enctype = ( @$ini_val('file_uploads') == '0' || strtolower(@$ini_val('file_uploads') == 'off') || phpversion() == '4.0.4pl1' || !$board_config['allow_avatar_upload'] || ( phpversion() < '4.0.3' && @$ini_val('open_basedir') != '' ) ) ? '' : 'enctype="multipart/form-data"';

	$template->assign_vars(array(
		'USERNAME' => $username,
		'CUR_PASSWORD' => $cur_password,
		'NEW_PASSWORD' => $new_password,
		'PASSWORD_CONFIRM' => $password_confirm,
		'EMAIL' => $email,
		'YIM' => $yim,
		'ICQ' => $icq,
		'MSN' => $msn,
		'AIM' => $aim,
		'INTERESTS' => $interests,
        'S_BIRTHDAY' => $s_birthday,
		'LOCATION' => $location,
        'LOCATION2' => $location2,
        'LOCK_GENDER' =>($mode!='register') ? 'DISABLED':'', 
        'GENDER' => $gender, 
        'GENDER_NO_SPECIFY_CHECKED' => $gender_no_specify_checked, 
        'GENDER_MALE_CHECKED' => $gender_male_checked, 
        'GENDER_FEMALE_CHECKED' => $gender_female_checked, 
		'WEBSITE' => $website,
		'SIGNATURE' => str_replace('<br />', "\n", $signature),
        'CHECK_EMAIL'    => ($userdata['user_viewemail']) ? 'checked="checked"' : '',
		'HIDE_USER_YES' => ( !$allowviewonline ) ? 'checked="checked"' : '',
		'HIDE_USER_NO' => ( $allowviewonline ) ? 'checked="checked"' : '',
		'NOTIFY_PM_YES' => ( $notifypm ) ? 'checked="checked"' : '',
		'NOTIFY_PM_NO' => ( !$notifypm ) ? 'checked="checked"' : '',
		'POPUP_PM_YES' => ( $popuppm ) ? 'checked="checked"' : '',
		'POPUP_PM_NO' => ( !$popuppm ) ? 'checked="checked"' : '',
		'ALWAYS_ADD_SIGNATURE_YES' => ( $attachsig ) ? 'checked="checked"' : '',
		'ALWAYS_ADD_SIGNATURE_NO' => ( !$attachsig ) ? 'checked="checked"' : '',
		'NOTIFY_REPLY_YES' => ( $notifyreply ) ? 'checked="checked"' : '',
		'NOTIFY_REPLY_NO' => ( !$notifyreply ) ? 'checked="checked"' : '',
		'NOTIFY_DONATION_YES' => ( $notifydonation ) ? 'checked="checked"' : '',
		'NOTIFY_DONATION_NO' => ( !$notifydonation ) ? 'checked="checked"' : '',
		'ALWAYS_ALLOW_BBCODE_YES' => ( $allowbbcode ) ? 'checked="checked"' : '',
		'ALWAYS_ALLOW_BBCODE_NO' => ( !$allowbbcode ) ? 'checked="checked"' : '',
		'ALWAYS_ALLOW_HTML_YES' => ( $allowhtml ) ? 'checked="checked"' : '',
		'ALWAYS_ALLOW_HTML_NO' => ( !$allowhtml ) ? 'checked="checked"' : '',
		'ALWAYS_ALLOW_SMILIES_YES' => ( $allowsmilies ) ? 'checked="checked"' : '',
		'ALWAYS_ALLOW_SMILIES_NO' => ( !$allowsmilies ) ? 'checked="checked"' : '',

		'ALLOW_AVATAR' => $board_config['allow_avatar_upload'],
		'AVATAR' => $avatar_img,
		'AVATAR_SIZE' => $board_config['avatar_filesize'],
		'LANGUAGE_SELECT' => language_select($user_lang, 'language'),
		'STYLE_SELECT' => style_select($user_style, 'style'),
		'TIMEZONE_SELECT' => tz_select($user_timezone, 'timezone'),
		'DATE_FORMAT' => $user_dateformat,
		'HTML_STATUS' => $html_status,
		'BBCODE_STATUS' => sprintf($bbcode_status, '<a href="' . append_sid("faq.$phpEx?mode=bbcode") . '" target="_phpbbcode">', '</a>'),
		'SMILIES_STATUS' => $smilies_status,

		'OCCUPATION' => user_select('occupation', $lang['Occ'], $occupation),
        'REALNAME' => $realname,

// Check Variable 
        'CHECK_NAME'     => ($userdata['user_view_name']) ? 'checked="checked"' : '',
        'CHECK_MPHONE'   => ($userdata['user_view_mphone']) ? 'checked="checked"' : '',
        'CHECK_HPHONE'   => ($userdata['user_view_hphone']) ? 'checked="checked"' : '',
        'CHECK_FROM'     => ($userdata['user_view_from']) ? 'checked="checked"' : '',
        'CHECK_OCC'      => ($userdata['user_view_occ']) ? 'checked="checked"' : '',
        'CHECK_PHOTO'    => ($userdata['user_view_photo']) ? 'checked="checked"' : '',
        'CHECK_HOME'     => ($userdata['user_view_home']) ? 'checked="checked"' : '',
        'CHECK_GENDER'   => ($userdata['user_view_gender']) ? 'checked="checked"' : '',
        'CHECK_BIRTH'    => ($userdata['user_view_birth']) ? 'checked="checked"' : '',

        'JUMIN1' => $jumin1,
        'JUMIN2' => $jumin2,
        'ZIPCODE1' => $zipcode1,
        'ZIPCODE2' => $zipcode2,
        'MPHONE1' => user_select('mphone1', $lang['mphone'], $mphone1),
        'MPHONE2' => $mphone2,
        'MPHONE3' => $mphone3,
        'HPHONE1' => user_select('hphone1', $lang['hphone'], $hphone1),
        'HPHONE2' => $hphone2,
        'HPHONE3' => $hphone3,

		'L_REALNAME' => $lang['realname'],
        'L_JUMIN' => $lang['Jumin'],
        'L_ZIPCODE' => $lang['Zipcode'],
        'L_MPHONE' => $lang['my_phone'],
        'L_HPHONE' => $lang['hand_phone'],
        'L_VIEW_PUBLIC' => $lang['view_public'],
        'L_VIEW_HIDDEN' => $lang['view_hidden'],
/***********************************************************************************/

		'L_CURRENT_PASSWORD' => $lang['Current_password'],
		'L_NEW_PASSWORD' => ( $mode == 'register' ) ? $lang['Password'] : $lang['New_password'],
		'L_CONFIRM_PASSWORD' => $lang['Confirm_password'],
		'L_CONFIRM_PASSWORD_EXPLAIN' => ( $mode == 'editprofile' ) ? $lang['Confirm_password_explain'] : '',
		'L_PASSWORD_IF_CHANGED' => ( $mode == 'editprofile' ) ? $lang['password_if_changed'] : '',
		'L_PASSWORD_CONFIRM_IF_CHANGED' => ( $mode == 'editprofile' ) ? $lang['password_confirm_if_changed'] : '',
		'L_SUBMIT' => $lang['Submit'],
		'L_RESET' => $lang['Reset'],
		'L_ICQ_NUMBER' => $lang['ICQ'],
		'L_MESSENGER' => $lang['MSNM'],
		'L_YAHOO' => $lang['YIM'],
		'L_WEBSITE' => $lang['Website'],
		'L_AIM' => $lang['AIM'],
		'L_LOCATION' => $lang['Location'],
		'L_LOCATION2' => $lang['Location2'],
		'L_OCCUPATION' => $lang['Occupation'],
		'L_BOARD_LANGUAGE' => $lang['Board_lang'],
		'L_BOARD_STYLE' => $lang['Board_style'],
		'L_TIMEZONE' => $lang['Timezone'],
		'L_DATE_FORMAT' => $lang['Date_format'],
		'L_DATE_FORMAT_EXPLAIN' => $lang['Date_format_explain'],
		'L_YES' => $lang['Yes'],
		'L_NO' => $lang['No'],
		'L_INTERESTS' => $lang['Interests'],
        'L_GENDER' =>$lang['Gender'], 
        'L_GENDER_MALE' =>$lang['Male'], 
        'L_GENDER_FEMALE' =>$lang['Female'], 
        'L_GENDER_NOT_SPECIFY' =>$lang['No_gender_specify'], 
        'L_BIRTHDAY_EX' => $lang['Birthday_explain'],
        'L_BIRTHDAY' => $lang['Birthday'],
		'L_ALWAYS_ALLOW_SMILIES' => $lang['Always_smile'],
		'L_ALWAYS_ALLOW_BBCODE' => $lang['Always_bbcode'],
		'L_ALWAYS_ALLOW_HTML' => $lang['Always_html'],
		'L_HIDE_USER' => $lang['Hide_user'],
		'L_ALWAYS_ADD_SIGNATURE' => $lang['Always_add_sig'],

		'L_AVATAR_PANEL' => $lang['Avatar_panel'],
		'L_AVATAR_EXPLAIN' => sprintf($lang['Avatar_explain'], $board_config['avatar_max_width'], $board_config['avatar_max_height'], (round($board_config['avatar_filesize'] / 1024))),
		'L_UPLOAD_AVATAR_FILE' => $lang['Upload_Avatar_file'],
		'L_UPLOAD_AVATAR_URL' => $lang['Upload_Avatar_URL'],
		'L_UPLOAD_AVATAR_URL_EXPLAIN' => $lang['Upload_Avatar_URL_explain'],
		'L_AVATAR_GALLERY' => $lang['Select_from_gallery'],
		'L_SHOW_GALLERY' => $lang['View_avatar_gallery'],
		'L_LINK_REMOTE_AVATAR' => $lang['Link_remote_Avatar'],
		'L_LINK_REMOTE_AVATAR_EXPLAIN' => $lang['Link_remote_Avatar_explain'],
		'L_DELETE_AVATAR' => $lang['Delete_Image'],
		'L_CURRENT_IMAGE' => $lang['Current_Image'],

		'L_SIGNATURE' => $lang['Signature'],
		'L_SIGNATURE_EXPLAIN' => sprintf($lang['Signature_explain'], $board_config['max_sig_chars']),
		'L_NOTIFY_ON_REPLY' => $lang['Always_notify'],
		'L_NOTIFY_ON_REPLY_EXPLAIN' => $lang['Always_notify_explain'],
		'L_NOTIFY_ON_PRIVMSG' => $lang['Notify_on_privmsg'],
		'L_POPUP_ON_PRIVMSG' => $lang['Popup_on_privmsg'],
		'L_POPUP_ON_PRIVMSG_EXPLAIN' => $lang['Popup_on_privmsg_explain'],
		'L_PREFERENCES' => $lang['Preferences'],
		'L_PUBLIC_VIEW_EMAIL' => $lang['Public_view_email'],
		'L_ITEMS_REQUIRED' => $lang['Items_required'],
		'L_REGISTRATION_INFO' => $lang['Registration_info'],
		'L_PROFILE_INFO' => $lang['Profile_info'],
		'L_PROFILE_INFO_NOTICE' => $lang['Profile_info_warn'],
		'L_EMAIL_ADDRESS' => $lang['Email_address'],
		'L_NOTIFY_DONATION' => sprintf($lang['Points_notify'], $board_config['points_name']),
		'L_NOTIFY_DONATION_EXPLAIN' => sprintf($lang['Points_notify_explain'], $board_config['points_name']),

		'S_ALLOW_AVATAR_UPLOAD' => $board_config['allow_avatar_upload'],
		'S_ALLOW_AVATAR_LOCAL' => $board_config['allow_avatar_local'],
		'S_ALLOW_AVATAR_REMOTE' => $board_config['allow_avatar_remote'],
		'S_HIDDEN_FIELDS' => $s_hidden_fields,
		'S_FORM_ENCTYPE' => $form_enctype,
		'S_PROFILE_ACTION' => append_sid("profile.$phpEx"))
	);

	//
	// This is another cheat using the block_var capability
	// of the templates to 'fake' an IF...ELSE...ENDIF solution
	// it works well :)
	//
	if ( $mode != 'register' )
	{
		if ( $userdata['user_allowavatar'] && ( $board_config['allow_avatar_upload'] || $board_config['allow_avatar_local'] || $board_config['allow_avatar_remote'] ) )
		{
			$template->assign_block_vars('switch_avatar_block', array() );

			if ( $board_config['allow_avatar_upload'] && file_exists(@phpbb_realpath('./' . $board_config['avatar_path'])) )
			{
				if ( $form_enctype != '' )
				{
					$template->assign_block_vars('switch_avatar_block.switch_avatar_local_upload', array() );
				}
				$template->assign_block_vars('switch_avatar_block.switch_avatar_remote_upload', array() );
			}

			if ( $board_config['allow_avatar_remote'] )
			{
				$template->assign_block_vars('switch_avatar_block.switch_avatar_remote_link', array() );
			}

			if ( $board_config['allow_avatar_local'] && file_exists(@phpbb_realpath('./' . $board_config['avatar_gallery_path'])) )
			{
				$template->assign_block_vars('switch_avatar_block.switch_avatar_local_gallery', array() );
			}
		}
	}
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>