<?php
/***************************************************************************
 *                           usercp_viewprofile.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: usercp_viewprofile.php,v 1.5 2002/03/31 00:06:34 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
	exit;
}

if ( empty($HTTP_GET_VARS[POST_USERS_URL]) || $HTTP_GET_VARS[POST_USERS_URL] == ANONYMOUS )
{
	message_die(GENERAL_MESSAGE, $lang['No_user_id_specified']);
}
$profiledata = get_userdata(intval($HTTP_GET_VARS[POST_USERS_URL]));

// Some parameters for the buddylist

$buddy_id = ( isset($HTTP_GET_VARS['b']) ) ? $HTTP_GET_VARS['b'] : 0;
$buddy_action = ( isset($HTTP_GET_VARS['buddy_action']) ) ? ( ($HTTP_GET_VARS['buddy_action'] == 'add') ? 'add' : ( ($HTTP_GET_VARS['buddy_action'] == 'remove') ? 'remove' : '') ) : '';

// Add to/remove from buddylist
//
if ( $buddy_id )
{
	$redirect = POST_USERS_URL . "=" . $profiledata['user_id'];
	$redirect .= "&mode=viewprofile";

	if( !$userdata['session_logged_in'] )
	{
		$redirect .= ( isset($buddy_id) ) ? '&b=$buddy_id' : '';
		$redirect .= ( isset($buddy_action) ) ? '&buddy_action=$buddy_action' : '';
		$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
		header($header_location . append_sid("login.$phpEx?redirect=profile.$phpEx&$redirect", true));
		exit;
	}

	if ( $buddy_action == 'add' )
	{
		if ( $buddy_id == $userdata['user_id'] )
		{
			message_die(GENERAL_MESSAGE, 'You cannot add yourself to your buddylist');
		}

		$sql = "SELECT * FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query buddylist information', '', __LINE__, __FILE__, $sql);
		}
		if ( $row = $db->sql_fetchrow($result) )
		{
			message_die(GENERAL_MESSAGE, 'User is already in your buddylist');
		}

		$sql = "INSERT INTO " . BUDDIES_TABLE . " VALUES (" . $userdata['user_id'] . "," . $buddy_id . ");";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not add the user to your buddylist', '', __LINE__, __FILE__, $sql);
		}

		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("profile.$phpEx?$redirect") . '">')
			);
		$message = $lang['Buddy_added'] . '<br /><br />' . sprintf($lang['Click_return_profile'], '<a href="' . append_sid ("profile.$phpEx?$redirect") . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);
	}

	if ( $buddy_action == 'remove' )
	{
		if ( $buddy_id == $userdata['user_id'] )
		{
			message_die(GENERAL_MESSAGE, 'You cannot remove yourself from your buddylist');
		}

		$sql = "SELECT * FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
		if( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query buddylist information', '', __LINE__, __FILE__, $sql);
		}
		if( !($row = $db->sql_fetchrow($result)) )
		{
			message_die(GENERAL_MESSAGE, 'User is not in your buddylist');
		}

		$sql = "DELETE FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = $buddy_id";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not remove the user from your buddylist', '', __LINE__, __FILE__, $sql);
		}

		$template->assign_vars(array(
			'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("profile.$phpEx?$redirect") . '">')
			);
		$message = $lang['Buddy_removed'] . '<br /><br />' . sprintf($lang['Click_return_profile'], '<a href="' . append_sid("profile.$phpEx?$redirect") . '">', '</a>');
		message_die(GENERAL_MESSAGE, $message);
	}
}

$sql = "SELECT *
	FROM " . RANKS_TABLE . "
	ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not obtain ranks information', '', __LINE__, __FILE__, $sql);
}

while ( $row = $db->sql_fetchrow($result) )
{
	$ranksrow[] = $row;
}
$db->sql_freeresult($result);

if ( $userdata['session_logged_in'] ){
	$sql = "SELECT buddy_id FROM " . BUDDIES_TABLE . " WHERE user_id = " . $userdata['user_id'] . " AND buddy_id = " . $profiledata['user_id'];
}
if ( !($result = $db->sql_query($sql)) ){
	message_die(GENERAL_ERROR, "Could not obtain buddies information.", '', __LINE__, __FILE__, $sql);
}

if ( $row = $db->sql_fetchrow($result) ){
	$buddy_id = $row['buddy_id'];
}

//
// Output page header and profile_view template
//
$template->set_filenames(array(
	'body' => 'profile_view_body.tpl')
);
make_jumpbox('viewforum.'.$phpEx);

//
// Calculate the number of days this user has been a member ($memberdays)
// Then calculate their posts per day
//
$regdate = $profiledata['user_regdate'];
$memberdays = max(1, round( ( time() - $regdate ) / 86400 ));
$posts_per_day = $profiledata['user_posts'] / $memberdays;

// Get the users percentage of total posts
if ( $profiledata['user_posts'] != 0  )
{
	$total_posts = get_db_stat('postcount');
	$percentage = ( $total_posts ) ? min(100, ($profiledata['user_posts'] / $total_posts) * 100) : 0;
}
else
{
	$percentage = 0;
}

$avatar_img = '';
if ( $profiledata['user_avatar_type'] && $profiledata['user_allowavatar'] )
{
	switch( $profiledata['user_avatar_type'] )
	{
		case USER_AVATAR_UPLOAD:
			$avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_REMOTE:
			$avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
		case USER_AVATAR_GALLERY:
			$avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
			break;
	}
}
//*********************************************************************************
//  Default Avatar MOD - Begin
//*********************************************************************************
if ( empty($avatar_img) ) {
	$avatar_img = '<img src="'.  $images['default_avatar'] .'" alt="" border="0" />';
}

$poster_rank = '';
$rank_image = '';
if ( $profiledata['user_rank'] )
{
	for($i = 0; $i < count($ranksrow); $i++)
	{
		if ( $profiledata['user_rank'] == $ranksrow[$i]['rank_id'] && $ranksrow[$i]['rank_special'] )
		{
			$poster_rank = $ranksrow[$i]['rank_title'];
			$rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
		}
	}
}
else
{
	for($i = 0; $i < count($ranksrow); $i++)
	{
		if ( $profiledata['user_posts'] >= $ranksrow[$i]['rank_min'] && !$ranksrow[$i]['rank_special'] )
		{
			$poster_rank = $ranksrow[$i]['rank_title'];
			$rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
		}
	}
}

$hidden_img = '<img src="' . $images['hidden_img'] . '" alt="' . $lang['pub_hidden'] . '" title="' . $lang['pub_hidden'] . '" align="middle" border="0" />';
$none_img = '<img src="' . $images['none_img'] . '" alt="' . $lang['pub_unknow'] . '" title="' . $lang['pub_unknow'] . '" align="middle" border="0" />';

// Set buddy items
$buddy_img = '';
$buddy = '';

if ( $userdata['session_logged_in'] && ( $userdata['user_id'] != $profiledata['user_id'] ) )
{
	$redirect = POST_USERS_URL . "=" . $profiledata['user_id'];
	$redirect .= "&mode=viewprofile";
	$redirect .= "&b=" . $profiledata['user_id'];
	
	if ( $buddy_id )
	{
		$redirect .= "&buddy_action=remove";
		$buddy_img = '<a href="' . append_sid("profile.$phpEx?$redirect") . '"><img src="' . $images['icon_buddy_remove'] . '" alt="' . $lang['Remove_buddy_list'] . '" border="0"></a>';
		$buddy = '<a href="' . append_sid("profile.$phpEx?$redirect") . '">' . $lang['Remove_buddy_list'] . '</a>';
	}
	else
	{
		$redirect .= "&buddy_action=add";
		$buddy_img = '<a href="' . append_sid("profile.$phpEx?$redirect") . '"><img src="' . $images['icon_buddy'] . '" alt="' . $lang['Add_buddy_list'] . '" border="0"></a>';
		$buddy = '<a href="' . append_sid("profile.$phpEx?$redirect") . '">' . $lang['Add_buddy_list'] . '</a>';
	}
}

$temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $profiledata['user_id']);
$pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
$pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';

if (!empty($profiledata['user_viewemail']) || $userdata['user_level'] == ADMIN ) {
	$email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $profiledata['user_id']) : 'mailto:' . $profiledata['user_email'];
	$email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
	$email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
} else {
	$email_img = "$hidden_img";
	$email = "$none_img";
}

if ($profiledata['user_website'] == '') {
    $www_img = "$none_img";
    $www = "$none_img";
}
elseif (!empty($profiledata['user_view_home']) || $userdata['user_level'] == ADMIN ) {
    $www_img = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '&nbsp;';
    $www = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww">' . $profiledata['user_website'] . '</a>' : '&nbsp;';
}
else {
    $www_img = '<img src="' . $images['icon_www_pub'] . '" alt="' . $lang['pub_hidden'] . '" title="' . $lang['pub_hidden'] . '" border="0" />';
    $www = '<img src="' . $images['icon_www_pub'] . '" alt="' . $lang['pub_hidden'] . '" title="' . $lang['pub_hidden'] . '" border="0" />';
} 

if ( !empty($profiledata['user_icq']) )
{
	$icq_status_img = '<a href="http://wwp.icq.com/' . $profiledata['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $profiledata['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
	$icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
	$icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '">' . $lang['ICQ'] . '</a>';
}
else
{
	$icq_status_img = '&nbsp;';
	$icq_img = '&nbsp;';
	$icq = '&nbsp;';
}

$aim_img = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '&nbsp;';
$aim = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '&nbsp;';

$msn_img = ( $profiledata['user_msnm'] ) ? $profiledata['user_msnm'] : '&nbsp;';
$msn = $msn_img;

$yim_img = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
$yim = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';

$temp_url = append_sid("search.$phpEx?search_author=" . urlencode($profiledata['username']) . "&amp;showresults=posts");
$search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . $lang['Search_user_posts'] . '" title="' . $lang['Search_user_posts'] . '" border="0" /></a>';
$search = '<a href="' . $temp_url . '">' . $lang['Search_user_posts'] . '</a>';
$username = $profiledata['username'];

$user_points = ($userdata['user_level'] == ADMIN || user_is_authed($userdata['user_id'])) ? '<a href="' . append_sid("pointscp.$phpEx?" . POST_USERS_URL . "=" . $profiledata['user_id']) . '" class="gen" title="' . sprintf($lang['Points_link_title'], $board_config['points_name']) . '">' . $profiledata['user_points'] . '</a>' : $profiledata['user_points'];

//*********************************************************************************
// Ʈ 
//*********************************************************************************
if ($board_config['points_donate'] && $userdata['user_id'] != ANONYMOUS && $userdata['user_id'] != $profiledata['user_id']) {
	$donate_points = '<br />' . sprintf($lang['Points_donate'], '<a href="' . append_sid("pointscp.$phpEx?mode=donate&amp;" . POST_USERS_URL . "=" . $profiledata['user_id']) . '" class="genmed" title="' . sprintf($lang['Points_link_title_2'], $board_config['points_name']) . '">', '</a>');
} else {
	$donate_points = '';
}
//************************************************************** ֹε ȣ
if($userdata['user_level'] == ADMIN) {
   if ($profiledata['user_jumin1'] !='') {
       $jumin_number = $profiledata['user_jumin1'].' - '.$profiledata['user_jumin2'];
   } else {
       $jumin_number = "$none_img";
   }
   $template->assign_vars(array(
       'L_USER_PERM_FOR' => $lang['User_perm_for'], 
       'U_PERM_PROFILE' => "<a href=\"" . append_sid("admin/admin_users.$phpEx?mode=edit&amp;u=" . $profiledata['user_id']) . "\" target=\"_blank\">" . '<img src="' . $images['s_edit'] . '" border="0">' . "</a> ",
	   'JUMIN_NUMBER' => $jumin_number,)
   );
   $template->assign_block_vars('switch_user_admin', array());
}
//*********************************************************************************
// Begin HP/MP/EXP Mod
//*********************************************************************************
/*
 * Note: all new variables used created in this mod
 * are prefixed with level_ to be sure of not overwriting
 * other variables.
 *
 */
 
/* Calculate Level
 * A user's level is determined by their total number of posts.
 * A nice mathmatical formula is used to translate their post count
 * into an intager level.
 *
 * Note: A user with zero (0) posts is considered level 0, however
 * making one (1) post, raises them to level 1.
 *
 */

if($profiledata['user_posts'] < 1)
{
	$level_level = 0;
}
else
{
	$level_level = floor( pow( log10( $profiledata['user_posts'] ), 3 ) ) + 1;
}

/* Determine Hit Points (HP)
 * 
 * Hp is based on user activity.
 * Max HP is based on the user's level, and will generally
 * be the same for all users of the same level.
 *
 * A user's current HP is based on the user's posts per day.
 * A higher post per day (ppd), the more HP they will have. A 
 * user with an average PPD (set below) will have 50% of their 
 * max HP. As a user goes over the average PPD, they will have 
 * more HP, but the gains will decrease as the user's PPD increases.
 * This makes achieving 100% hp difficult, but not impossible.
 *
 * For users with under the average PPD, they will have HP equal
 * to 1/2 the percentage their ppd is of the average.
 * ie- a user with 2.5 ppd, and an average ppd of 5 will have
 * 25% of their max HP. This is because 2.5 is 50% of 5, and 1/2
 * of that, is 25%.
 *
 * Users who manage to post so far above the average that they have
 * more HP than their max will recieve a bonus to their max HP.
 *
 * Note that users at level 0 will always have 0 / 0 hp.
 *
 */

/*
 * This value determines the 'average' posts per day.
 * The admin may redefine this variable as he wishes. 
 * Higher values will generally decrease users' HP, and
 * lower values will generally increase users' HP.
 *
 * Note: Do NOT set this value to zero (0).
 * This -may- be set to a fractional value (eg, 5.1, 3.1415)
 *
 */

$level_avg_ppd = 5;

/* 
 * this value sets how hard it is to achieve 100%
 * hp. The higher you set it, the harder it is to
 * get full hp.
 *
 * to judge how high to set it, a user must have
 * posts per day equal to the $level_avg_ppd plus
 * the number set below.
 * 
 * This should NOT be zero.
 */
 
$level_bonus_redux = 5;

if($level_level < 1)
{
	$level_hp = "0 / 0";
	$level_hp_percent = 0;
}
else
{
	$level_max_hp = floor( (pow( $level_level, (1/4) ) ) * (pow( 10, pow( $level_level+2, (1/3) ) ) ) / (1.5) );

	if($posts_per_day >= $level_avg_ppd)
	{
		$level_hp_percent = floor( (.5 + (($posts_per_day - $level_avg_ppd) / ($level_bonus_redux * 2)) ) * 100);
	}
	else
	{
		$level_hp_percent = floor( $posts_per_day / ($level_avg_ppd / 50) );
	}
	
	if($level_hp_percent > 100)
	{
		//Give the user a bonus to max HP for greater than 100% hp.
		$level_max_hp += floor( ($level_hp_percent - 100) * pi() );
		$level_hp_percent = 100;
	}
	else
	{
		$level_hp_percent = max(0, $level_hp_percent);
	}
	
	$level_cur_hp = floor($level_max_hp * ($level_hp_percent / 100) );
	
	//Be sure a user has no more than max, and no less than zero hp.
	$level_cur_hp = max(0, $level_cur_hp);
	$level_cur_hp = min($level_max_hp, $level_cur_hp);
	
	$level_hp = $level_cur_hp . ' / ' . $level_max_hp;
}

/* Determine MP
 * 
 * MP is calculated by how long the user has been around
 * and how often they post.
 * 
 * Max MP is based on level, and increases with level
 * Each post a user makes costs them mp,
 * and a user regenerates mp proportional to how
 * many days they have been registered
 *
 */
 
//Number of days the user has been at the forums.
$level_user_days = max(1, round( ( time() - $profiledata['user_regdate'] ) / 86400 ));

/* The mp cost for one post.
 * Raising this value will generally decrease the current
 * mp for most posters.
 * This may be set to a decimal value (eg, 2, 2.1, 3.141596)
 * This should NOT be set to 0
 */
$level_post_mp_cost = 2.5;

/* This determines how much mp a user regenerates per day
 * Raising this value will generally increase the current
 * mp for most posters.
 * This may be set to a decimal value (eg, 3, 3.5, 2.71828)
 * This should NOT be set to 0
 */
$level_mp_regen_per_day = 4;

if($level_level < 1)
{
	$level_mp = '0 / 0';
	$level_mp_percent = 0;
}
else
{
	$level_max_mp = floor( (pow( $level_level, (1/4) ) ) * (pow( 10, pow( $level_level+2, (1/3) ) ) ) / (pi()) );
	
	$level_mp_cost = $profiledata['user_posts'] * $level_post_mp_cost;
	$level_mp_regen = max(1, $level_user_days * $level_mp_regen_per_day);
	
	$level_cur_mp = floor($level_max_mp - $level_mp_cost + $level_mp_regen);
	$level_cur_mp = max(0, $level_cur_mp);
	$level_cur_mp = min($level_max_mp, $level_cur_mp);
	
	$level_mp = $level_cur_mp . ' / ' . $level_max_mp;
	$level_mp_percent = floor($level_cur_mp / $level_max_mp * 100 );
	
}

/* Determine EXP percentage
 *
 * Experience is determined by how far the user is away
 * from the next level. This is expressed as a percentage.
 * 
 * Note, a user of level 0 has 100% experience. Making one post
 * will put them at level 1. Also, a user that is shown to have 100%
 * experience, will go up a level on their next post.
 *
 */

if($level_level == 0)
{
	$level_exp = "0 / 0";
	$level_exp_percent = 100;
}
else
{
	$level_posts_for_next = floor( pow( 10, pow( $level_level, (1/3) ) ) );
	

	$level_posts_for_this = max(1, floor( pow( 10, pow( ($level_level - 1), (1/3) ) ) ) );
	

	
	$level_exp = ($profiledata['user_posts'] - $level_posts_for_this) . " / " . ($level_posts_for_next - $level_posts_for_this);
	
	$level_exp_percent = floor( ( ($profiledata['user_posts'] - $level_posts_for_this) / max( 1, ($level_posts_for_next - $level_posts_for_this ) ) ) * 100);
}

//*********************************************************************************
// END HP/MP/EXP Mod
//*********************************************************************************

//-----------------------------------------------------------------------------------
//  Ż αŸ 
//-----------------------------------------------------------------------------------
     $total_time = $profiledata['user_totaltime'];

     $hour = floor($total_time / 3600);
     $total_time = $total_time - ($hour*3600);
     $min = floor($total_time / 60);
     $sek = $total_time - ($min * 60);

//
// Generate page
//
$page_title = $lang['Viewing_profile'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);
display_upload_attach_box_limits($profiledata['user_id']);

$template->assign_vars(array(
	'USERNAME' => $username,
    'REALNAME' => perm_realname($profiledata),
	'JOINED' => create_date($lang['DATE_FORMAT'], $profiledata['user_regdate'], $board_config['board_timezone']),
    'L_LOGON' => $lang['Last_logon'], 
    'LAST_LOGON' => ($userdata['user_level'] == ADMIN || (!$board_config['hidde_last_logon'] && $profiledata['user_allow_viewonline'])) ? (($profiledata['user_lastlogon'])? create_date($board_config['default_dateformat'], $profiledata['user_lastlogon'], $board_config['board_timezone']):$lang['Never_last_logon']):$lang['Hidde_last_logon'], 

    'L_TOTAL_ONLINE_TIME' => $lang['Total_online_time'],
    'TOTAL_ONLINE_TIME' => $hour.'ð '.$min.' '.$sek.'',//make_hours($profiledata['user_totaltime']),
    'L_LAST_ONLINE_TIME' => $lang['Last_online_time'],
    'LAST_ONLINE_TIME' => make_hours($profiledata['user_session_time']-$profiledata['user_lastlogon']),
    'L_NUMBER_OF_VISIT' => $lang['Number_of_visit'],
    'NUMBER_OF_VISIT' => ($profiledata['user_totallogon']>0) ? $profiledata['user_totallogon']: $lang['None'],
    'L_NUMBER_OF_PAGES' => $lang['Number_of_pages'], 
    'NUMBER_OF_PAGES' => ($profiledata['user_totalpages']) ? $profiledata['user_totalpages']: $lang['None'], 

	'POSTER_RANK' => $poster_rank,
	'RANK_IMAGE' => $rank_image,
	'POSTS_PER_DAY' => $posts_per_day,
	'POSTS' => $profiledata['user_posts'],
	'PERCENTAGE' => $percentage . '%', 
	'POST_DAY_STATS' => sprintf($lang['User_post_day_stats'], $posts_per_day), 
	'POST_PERCENT_STATS' => sprintf($lang['User_post_pct_stats'], $percentage), 

	'SEARCH_IMG' => $search_img,
	'SEARCH' => $search,
	'PM_IMG' => $pm_img,
	'PM' => $pm,
	'EMAIL_IMG' => $email_img,
	'EMAIL' => $email,
	'WWW_IMG' => $www_img,
	'WWW' => $www,
	'BUDDY_IMG' => $buddy_img,
	'BUDDY' => $buddy,
	'ICQ_STATUS_IMG' => $icq_status_img,
	'ICQ_IMG' => $icq_img, 
	'ICQ' => $icq, 
	'AIM_IMG' => $aim_img,
	'AIM' => $aim,
	'MSN_IMG' => $msn_img,
	'MSN' => $msn,
	'YIM_IMG' => $yim_img,
	'POINTS' => $user_points,
	'DONATE_POINTS' => $donate_points,
	'YIM' => $yim,

	'LOCATION' => perm_from($profiledata,''),
	'OCCUPATION' => perm_occ($profiledata),

    'MPHONE' => perm_mphone($profiledata),
    'HPHONE' => perm_hphone($profiledata),

	'INTERESTS' => ( $profiledata['user_interests'] ) ? $profiledata['user_interests'] : '&nbsp;',
    'GENDER' => perm_gender($profiledata),
    'BIRTHDAY' => perm_birth_age($profiledata,'B'),
    'USER_AGE' => perm_birth_age($profiledata,'A'),
	'AVATAR_IMG' => $avatar_img,

	'L_VIEWING_PROFILE' => sprintf($lang['Viewing_user_profile'], $username), 
	'L_ABOUT_USER' => sprintf($lang['About_user'], $username), 
	'L_AVATAR' => $lang['Avatar'], 
	'L_POSTER_RANK' => $lang['Poster_rank'], 
	'L_JOINED' => $lang['Joined'], 
	'L_TOTAL_POSTS' => $lang['Total_posts'], 
	'L_SEARCH_USER_POSTS' => sprintf($lang['Search_user_posts'], $username), 
	'L_CONTACT' => $lang['Contact'],
	'L_EMAIL_ADDRESS' => $lang['Email_address'],
	'L_EMAIL' => $lang['Email'],
	'L_PM' => $lang['Private_Message'],
	'L_ICQ_NUMBER' => $lang['ICQ'],
	'L_YAHOO' => $lang['YIM'],
	'L_AIM' => $lang['AIM'],
	'L_MESSENGER' => $lang['MSNM'],
	'L_WEBSITE' => $lang['Website'],
	'L_BUDDY' => $lang['Buddy'],
	'L_LOCATION' => $lang['Location'],
	'L_OCCUPATION' => $lang['Occupation'],
	'L_INTERESTS' => $lang['Interests'],
	'L_POINTS' => $board_config['points_name'],
    'L_GENDER' => $lang['Gender'],
    'L_BIRTHDAY' => $lang['Birthday'], 
	'L_REALNAME' => $lang['realname'],
	'L_HPHONE' => $lang['hand_phone'],
	'L_MPHONE' => $lang['my_phone'],
    'L_JUMIN' => $lang['Jumin'],
    'L_AGE' => $lang['Age'],

	'L_P_LEVEL' => $lang['P_level'],
	'L_LEVEL' => $lang['Level'], 

    /* BEGIN LEVEL MOD */
    'HP' => $level_hp,
    'HP_WIDTH' => $level_hp_percent,
    'HP_EMPTY' => ( 100 - $level_hp_percent ),
    'MP' => $level_mp,
    'MP_WIDTH' => $level_mp_percent,
    'MP_EMPTY' => ( 100 - $level_mp_percent ),
    'EXP' => $level_exp,
    'EXP_WIDTH' => $level_exp_percent,
    'EXP_EMPTY' => ( 100 - $level_exp_percent ),
    'LEVEL' => $level_level,
    /* END LEVEL MOD */

	'U_SEARCH_USER' => append_sid("search.$phpEx?search_author=" . urlencode($profiledata['username'])),
	// Photo Album Addon v2.x.x by Smartor
	//
	'U_PERSONAL_GALLERY' => append_sid("album_personal.$phpEx?user_id=" . $profiledata['user_id']),
	'L_PERSONAL_GALLERY' => sprintf($lang['Personal_Gallery_Of_User'], $profiledata['username']),

	'S_PROFILE_ACTION' => append_sid("profile.$phpEx"))
);

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>