<?php
/***************************************************************************
 *                                index.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: index.php,v 1.99.2.1 2002/12/19 17:17:40 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

$tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . "_t"]) : array();
$tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . "_f"]) : array();
$is_auth_ary = array();
$is_auth_ary = auth(AUTH_VIEW, AUTH_LIST_ALL, $userdata, $forum_data);

//
// If you don't use these stats on your index you may want to consider
// removing them
//
$total_posts = get_db_stat('postcount');
$total_users = get_db_stat('usercount');
$newest_userdata = get_db_stat('newestuser');
$newest_user = $newest_userdata['username'];
$newest_uid = $newest_userdata['user_id'];
$ezm_m = explode(',',$board_config['ezm_manager']);

if( $total_users == 0 ) {
	$l_total_user_s = $lang['Registered_users_zero_total'];
} else if( $total_users == 1 ) {
	$l_total_user_s = $lang['Registered_user_total'];
} else {
	$l_total_user_s = $lang['Registered_users_total'];
}
    $tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . "_t"]) : array();
    $tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . "_f"]) : array();

	$is_auth_ary = array();
	$is_auth_ary = auth(AUTH_VIEW, AUTH_LIST_ALL, $userdata, $forum_data);

// Birthday Mod, Show users with birthday 
$sql = ($board_config['birthday_check_day']) ? "SELECT user_id, username, user_birthday,user_level,user_view_birth FROM " . USERS_TABLE. " WHERE user_birthday!=999999 ORDER BY username" :"";
if($result = $db->sql_query($sql)) 
{ 
	if (!empty($result)) 
	{ 
		$time_now = time();
		$this_year = create_date('Y', $time_now, $board_config['board_timezone']);
		$date_today = create_date('Ymd', $time_now, $board_config['board_timezone']);
		$date_forward = create_date('Ymd', $time_now+($board_config['birthday_check_day']*86400), $board_config['board_timezone']);
	      while ($birthdayrow = $db->sql_fetchrow($result))
		{ 
		      $user_birthday2 = $this_year.($user_birthday = realdate("md",$birthdayrow['user_birthday'] )); 
      		if ( $user_birthday2 < $date_today ) $user_birthday2 += 1000;
			if ( $user_birthday2 > $date_today  && $user_birthday2 <= $date_forward ) 
			{ 
				// user are having birthday within the next days
                $user_age = ($birthdayrow['user_view_birth'] != 0 || $userdata['user_level'] == ADMIN) ? $user_age = ( $this_year.$user_birthday < $date_today ) ? $this_year - realdate ('Y',$birthdayrow['user_birthday'])+1 : $this_year- realdate ('Y',$birthdayrow['user_birthday']) : '<img src="' . $images['hidden_img'] . '" align="middle" border="0" />';

				switch ($birthdayrow['user_level'])
				{
					case ADMIN :
		      			$birthdayrow['username'] = '<b>' . $birthdayrow['username'] . '</b>'; 
      					$style_color = 'style="color:#' . $theme['fontcolor3'] . '"';
						break;
					case MOD :
		      			$birthdayrow['username'] = '<b>' . $birthdayrow['username'] . '</b>'; 
      					$style_color = 'style="color:#' . $theme['fontcolor2'] . '"';
						break;
					default: $style_color = '';
				}
				$birthday_week_list .= ' <b>::</b> <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $birthdayrow['user_id']) . '"' . $style_color .'>' . $birthdayrow['username'] . ' ('.$user_age.')</a><br />'; 
			} else if ( $user_birthday2 == $date_today ) 
      		{ 
				//user have birthday today 
                $user_age = ($birthdayrow['user_view_birth'] != 0 || $userdata['user_level'] == ADMIN) ? $this_year - realdate ( 'Y',$birthdayrow['user_birthday'] ) : '<img src="' . $images['hidden_img'] . '" align="middle" border="0" />';

				switch ($birthdayrow['user_level'])
				{
					case ADMIN :
		      			$birthdayrow['username'] = '<b>' . $birthdayrow['username'] . '</b>'; 
      					$style_color = 'style="color:#' . $theme['fontcolor3'] . '"';
						break;
					case MOD :
			      		$birthdayrow['username'] = '<b>' . $birthdayrow['username'] . '</b>'; 
      					$style_color = 'style="color:#' . $theme['fontcolor2'] . '"';
						break;
					default: $style_color = '';
				}
				$birthday_today_list .= ' <b>::</b> <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $birthdayrow['user_id']) . '"' . $style_color .'>' . $birthdayrow['username'] . ' ('.$user_age.')</a><br />'; 
		      }
			 
		}
		if ($birthday_today_list) $birthday_today_list[ strlen( $birthday_today_list)-1] = ' ';
		if ($birthday_week_list) $birthday_week_list[ strlen( $birthday_week_list)-1] = ' ';
	} 
	$db->sql_freeresult($result);
}

//show dayly users mod 
$time_now=time();
$time1Hour=$time_now-3600;
$minutes = date('is', $time_now);
$hour_now = $time_now - (60*($minutes[0].$minutes[1])) - ($minutes[2].$minutes[3]); 
$dato=create_date('H', $time_now,$board_config['board_timezone']);
$timetoday = $hour_now - (3600*$dato); 

$sql = 'SELECT session_ip, MAX(session_time) as session_time FROM '.SESSIONS_TABLE.' WHERE session_user_id="'.ANONYMOUS.'" AND session_time >= '.$timetoday.' AND session_time< '.($timetoday+86399).' GROUP BY session_ip';
if (!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, "Couldn't retrieve guest user today data", "", __LINE__, __FILE__, $sql); 

while( $guest_list = $db->sql_fetchrow($result)) { 
	if ($guest_list['session_time'] >$time1Hour) $users_lasthour++;
}
$guests_today = $db->sql_numrows($result);

$sql = 'SELECT user_id,username,user_allow_viewonline,user_level,user_lastlogon FROM ' . USERS_TABLE . ' WHERE user_id!="'.ANONYMOUS.'" AND user_session_time >= '.$timetoday.' AND user_session_time< '.($timetoday+86399).' ORDER BY username'; 
if (!$result = $db->sql_query($sql)) message_die(GENERAL_ERROR, "Couldn't retrieve user today data", "", __LINE__, __FILE__, $sql); 

while( $todayrow = $db->sql_fetchrow($result)) { 
	$style_color = ""; 

	if ($todayrow['user_lastlogon']>=$time1Hour) {
		$users_lasthour++;
	}
	switch ($todayrow['user_level']) {
		case ADMIN :
		    $todayrow['username'] = '<b>' . $todayrow['username'] . '</b>'; 
      		$style_color = 'style="color:#' . $theme['fontcolor3'] . '"';
			break;
		case MOD :
		      $todayrow['username'] = '<b>' . $todayrow['username'] . '</b>'; 
      		$style_color = 'style="color:#' . $theme['fontcolor2'] . '"';
			break;
	}
    $users_today_list.=( $todayrow['user_allow_viewonline'])?' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $todayrow['user_id']) . '"' . $style_color .'>' . $todayrow['username'] . '</a>,' : (($userdata[user_level]==ADMIN) ? ' <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $todayrow['user_id']) . '"' . $style_color .'><i>' . $todayrow['username'] . '</i></a>,' : '');
    if (!$todayrow['user_allow_viewonline']) $logged_hidden_today++;
    else $logged_visible_today++;
}

if ($users_today_list) { $users_today_list[ strlen( $users_today_list)-1] = ' '; }
else { $users_today_list = 'ȸ'.$lang['None'] .' ,&nbsp;'; }
$total_users_today = $db->sql_numrows($result)+$guests_today;
$users_today_list = $lang['Registered_users'].' ' . $users_today_list; // ⼮

$l_today_t_users = ($total_users_today) ? ( ( $total_users_today == 1 )? $lang['User_today_total'] : $lang['Users_today_total'] ) : $lang['Users_today_zero_total'];
$l_today_t_users = sprintf($l_today_t_users, $total_users_today); //  湮 

$l_today_regtotal = ($logged_visible_today) ? ( ( $logged_visible_today == 1 ) ? $lang['Today_reg_total'] : $lang['Today_reg_totals'] ) : $lang['Reg_users_zero_total'];
$l_today_regtotal = sprintf($l_today_regtotal, $logged_visible_today); // ȸ   

$l_today_r_user_s = ($logged_visible_today) ? ( ( $logged_visible_today == 1 ) ? $lang['Reg_user_total'] : $lang['Reg_users_total'] ) : $lang['Reg_users_zero_total'];
$l_today_h_user_s = ($logged_hidden_today) ? (($logged_hidden_today == 1) ? $lang['Hidden_user_total'] : $lang['Hidden_users_total'] ) : $lang['Hidden_users_zero_total'];
$l_today_g_user_s = ($guests_today) ? (($guests_today == 1) ? $lang['Guest_user_total'] : $lang['Guest_users_total']) : $lang['Guest_users_zero_total'];
$l_today_users = sprintf($l_today_r_user_s, $logged_visible_today); 
$l_today_users .= sprintf($l_today_h_user_s, $logged_hidden_today); 
$l_today_users .= sprintf($l_today_g_user_s, $guests_today);

//--------------------------------------------------------------- START SAVE TODAYOUNTER
$sql='SELECT guest, hidden, users, total FROM '.LOGCOUNTER_TABLE.' WHERE count_day='.$hour_now;
$result = @$db->sql_query($sql);

if ($old_data = $db->sql_fetchrow($result)) {
	if ($old_data['guest'] != $guests_today || $old_data['hidden'] != $logged_hidden_today || $old_data['users'] != $logged_visible_today || $old_data['total'] != $total_users_today) {
        $sql='UPDATE '.LOGCOUNTER_TABLE.' SET  guest="'.$guests_today.'", hidden="'.$logged_hidden_today.'", users="'.$logged_visible_today.'", total="'.$total_users_today.'" WHERE count_day='.$hour_now;
	    @$db->sql_query($sql);
    }
} else {
	$sql = 'INSERT INTO '.LOGCOUNTER_TABLE.' (count_day,guest,hidden,users,total)
		    VALUES ('.$hour_now.', "'.$guests_today.'", "'.$logged_hidden_today.'", "'.$logged_visible_today.'", "'.$total_users_today.'")';
	@$db->sql_query($sql);
}
$db->sql_freeresult($result);
//---------------------------------------------------------------- END SAVE TODAYCOUNTER

	//
	// Start output of page
	//
	define('SHOW_ONLINE', true);
	$page_title = $lang['Index'];
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	$template->set_filenames(array(
		'body' => 'index_body.tpl')
	);
//------------------------------------------------------------------ ε   
    $sql = "SELECT t.topic_id, t.topic_title, t.topic_last_post_id, t.topic_replies, t.topic_icon, u.user_id, u.username, u.user_avatar,u.user_allowavatar, u.user_avatar_type, u.user_allowsmile, p.post_id, p.post_time, pt.post_id, pt.bbcode_uid, pt.post_text, f.forum_id 
             FROM " . TOPICS_TABLE . " AS t, " . USERS_TABLE . " AS u, " . POSTS_TABLE . " AS p, " . POSTS_TEXT_TABLE . " AS pt, " . FORUMS_TABLE . " AS f
             WHERE t.forum_id = f.forum_id AND f.auth_view = " . AUTH_ALL . " AND t.topic_poster = u.user_id AND p.topic_id = t.topic_id AND p.post_id = t.topic_last_post_id AND p.post_id = pt.post_id ORDER BY p.post_time DESC LIMIT 1";
    if (!($result = $db->sql_query($sql))) {
	    message_die(GENERAL_ERROR, 'ֱٵϱ  ', '', __LINE__, __FILE__, $sql);
    }

    while ($row = $db->sql_fetchrow($result)) {
        $topic_title = str_cut($row['topic_title'], "40", "...");
        $topic_title = "<a href=\"" . append_sid("viewtopic.php?t=".$row['topic_id']) . "\" class=black>" . $topic_title . "</a>";
        $p_text = str_cut($row['post_text'], "300", "....");
        $p_text = nl2br($p_text); 
        $bbcode_uid = $row['bbcode_uid']; 

        if ($bbcode_uid != "" )
        {
          include($phpbb_root_path . 'includes/bbcode.'.$phpEx); 
          $p_text = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($p_text, $bbcode_uid) : preg_replace("/\:[0-9a-z\:]+\]/si", "]", $p_text); 
          $p_text = ( $board_config['allow_smilies'] ) ? smilies_pass($p_text) : str_replace("\n", "\n<br />\n", $p_text); 
        } 
        if (!$board_config['allow_html'] ) { 
            $p_text = preg_replace('#(<)([\/]?.*?)(>)#is', "&\\2&", $p_text); 
        }

        $avatar_img = '';
        if ($row['user_avatar_type'] && $row['user_allowavatar'] ) {
	        switch( $row['user_avatar_type'] )	{
		       case USER_AVATAR_UPLOAD:
			       $avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $row['user_avatar'] . '" alt="" border="0" />' : '';
			       break;
		       case USER_AVATAR_REMOTE:
			       $avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $row['user_avatar'] . '" alt="" border="0" />' : '';
			       break;
		       case USER_AVATAR_GALLERY:
			       $avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $row['user_avatar'] . '" alt="" border="0" />' : '';
			       break;
	        }
        }
        if (empty($row['user_avatar']) && $row['user_id'] != ANONYMOUS) {
		    $avatar_img = '<img src="'.  $images['default_avatar'] .'" alt="" border="0" />';
	    }
	    if ($row['user_id'] == ANONYMOUS ) {
		    $avatar_img = '<img src="'.  $images['guest_avatar'] .'" alt="" border="0" />';
	    }
        $name_link = ($row['user_id'] != '-1') ? '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;u=" . $row['user_id']) . '" class=small>' . $row['username'] . '</a>' : $lang['Guest'];

        $template->assign_block_vars('top_post', array( 
            'MESSAGE' => $p_text,
            'U_NAME_LINK' => $name_link,
    	    'AVATAR_IMG' => $avatar_img,
            'MORE_LINK' => '<a href="' . append_sid("viewtopic.php?t=".$row['topic_id']) . '">' .'<img src="'.  $images['more'] .'" alt="" border="0" />' . '</a>',
            'TOPIC_TITLE' => $topic_title,
            'POST_USERNAME' => '<a href="' . append_sid("profile.php?mode=viewprofile&u=".$row['user_id']) . '">' . $row['username'] . '</a>',
            'POST_NUMBER' => $row['topic_replies'],
            'POST_TIME' => create_date($board_config['default_dateformat'], $row['post_time'], $board_config['board_timezone']) )
        );
    }
//----------------------------------------------------------------------  ̱
    switch($ezm_m[1])
    {
        case '1' : $noti_type = "'1','2','3'"; break;
        case '2' : $noti_type = '1'; break;
        case '3' : $noti_type = '2'; break;
        case '4' : $noti_type = '3'; break;
    }
    $sql = "SELECT topic_id,topic_title,topic_time,topic_views FROM " . TOPICS_TABLE . " WHERE topic_type IN ($noti_type) ORDER BY topic_time DESC LIMIT $ezm_m[0]";
    if (!($result = $db->sql_query($sql))) 
    {
	    message_die(GENERAL_ERROR, '   ', '', __LINE__, __FILE__, $sql);
    }
    while ($row = $db->sql_fetchrow($result)) $notice_row[] = $row;
    if (count($notice_row) > 0) 
    {
        for ($i = 0; $i < count($notice_row); $i++)
        {
            $template->assign_block_vars('notice_topic', array( 
                'NOTI_ID' => append_sid("viewtopic.php?t=".$notice_row[$i]['topic_id']),
                'NOTI_TIME' => date("m-d", $notice_row[$i]['topic_time']),
                'NOTI_TITLE' => str_cut($notice_row[$i]['topic_title'], "$ezm_m[2]*2", '..'))
            );
        }
     } 
     else 
     {
         $template->assign_block_vars('no_notice', array());
     }
//---------------------------------------------------------------------- Links site!
    $sql = "SELECT id,url,name,added,clickcounter,user FROM ".LINKS_URL_TABLE." ORDER BY added DESC LIMIT $ezm_m[3]"; //  
    if (!($result = $db->sql_query($sql))) {
	    message_die(GENERAL_ERROR, 'Links  ', '', __LINE__, __FILE__, $sql);
    }

    while($row = $db->sql_fetchrow($result) ) { 
        $new_title = str_cut($row['name'], "$ezm_m[4]*2", '...');
        $new_link = '<a href="' . append_sid("./links.php?mode=show&id=" . $row[id]) . '">' . $new_title . '</a>'; 

        $template->assign_block_vars('recent_links', array( 
            'LINK_DATE' => date("m-d",$row[added]),
            'LINK_COUNTER' => $row['clickcounter'],
            'NEW_LINK'  => $new_link) 
        );
    }
//---------------------------------------------------------------------- ֱٵ  
    $sql = "SELECT t.topic_id, t.topic_time, t.topic_title, t.topic_last_post_id, t.topic_replies, t.topic_icon, p.post_time
            FROM " . TOPICS_TABLE . " AS t, " . POSTS_TABLE . " AS p, " . FORUMS_TABLE . " AS f
            WHERE t.forum_id = f.forum_id AND f.auth_view = " . AUTH_ALL . " AND p.topic_id = t.topic_id AND p.post_id = t.topic_last_post_id ORDER BY p.post_time DESC LIMIT 1,$ezm_m[5]";
    if (!($result = $db->sql_query($sql))) {
	    message_die(GENERAL_ERROR, 'ֱٵϱ  ', '', __LINE__, __FILE__, $sql);
    }

    while ($row = $db->sql_fetchrow($result)) {
        $topictitle = str_cut($row['topic_title'], "$ezm_m[6]*2", '..');
        $topictitle = '<a href="' . append_sid("viewtopic.php?t=".$row['topic_id']). '">' . $topictitle . '</a>';

        $template->assign_block_vars('recent_topic', array ( 
            'TOPIC_ID' => append_sid("viewtopic.php?t=".$row['topic_id']),
            'TOPIC_TITLE' => $topictitle,
            'TOPIC_ICON' => $row['topic_icon'],
            'TOPIC_REPLIES' => $row['topic_replies'],
            'TOPIC_TIME' => date("m-d", $row['topic_time']))
        );
    }
//------------------------------------------------------------------------  Խù
function top_topic($limit,$top_mode,$str) 
{

    global $db,$template;

    $sql="SELECT t.topic_title,t.topic_views,t.topic_replies,t.topic_id,t.topic_icon 
        FROM " . TOPICS_TABLE . " AS t, " . FORUMS_TABLE . " AS f
        WHERE t.forum_id = f.forum_id AND f.auth_view = " . AUTH_ALL . "  
        ORDER BY $top_mode DESC LIMIT $limit"; 
    if (!($result = $db->sql_query($sql))) 
    {
	    message_die(GENERAL_ERROR, ' "' . $top_mode . '" Խù  ', '', __LINE__, __FILE__, $sql);
    }
    while ($row = $db->sql_fetchrow($result)) 
    {
        $title = str_cut($row['topic_title'], "$str*2", '..');
        $title = '<a href="' . append_sid("viewtopic.php?t=".$row['topic_id']). '">' . $title . '</a>';

        $template->assign_block_vars("$top_mode", array( 
           'TOPIC_REPLIES' => $row['topic_replies'],
	       'TOPIC_ID' => append_sid("viewtopic.php?t=".$row['topic_id']),
	       'TOPIC_TITLE' => $title,
	       'TOPIC_ICON' => $row['topic_icon'],
	       'TOPIC_COUNT' => $row['topic_views'])
        );
    }
}
//------------------------------------------------------------------------- ̹ 
    // ַ  2.x 
    $sql = "SELECT pic_id, pic_title, pic_username, pic_time, pic_filename FROM ".ALBUM_TABLE." ORDER BY pic_time DESC LIMIT $ezm_m[11]"; // ַ̹ 
    if (!($result = $db->sql_query($sql))) {
	    message_die(GENERAL_ERROR, 'ַ  ', '', __LINE__, __FILE__, $sql);
    }
    $album_img_path = $phpbb_root_path . 'album_mod/upload/';
    while ($row = $db->sql_fetchrow($result)) {
        $image_row[] = $row;
    }
    if (count($image_row) > 0) {
        for ($i = 0; $i < count($image_row); $i++) {
             $template->assign_block_vars('recent_image', array( 
	            'PIC_TITLE' => str_cut($image_row[$i]['pic_title'], "$ezm_m[12]*2", '...'),
                'PIC_IMAGE' => '<img src="' . $album_img_path . $image_row[$i]['pic_filename'] . '" width="120"  height="120" border="0">',
	            'PIC_POSTER' => $image_row[$i]['pic_username'],
	            'U_PIC_LINK' => append_sid('album_pic.' . $phpEx . '?pic_id=' . $image_row[$i]['pic_id']),
                'PIC_DATE' => date("m d", $image_row[$i]['pic_time']))
             );
         }
    } else { 
        $template->assign_block_vars('no_pic', array());
    }
//-------------------------------------------------------------------------    
    $sql="SELECT user_id,username,user_posts FROM " . USERS_TABLE . " WHERE user_id > 0 AND user_id NOT IN (2) ORDER BY user_posts DESC LIMIT $ezm_m[13]"; 
    if (!($result = $db->sql_query($sql))) {
	    message_die(GENERAL_ERROR, 'TOP POSTER  ', '', __LINE__, __FILE__, $sql);
    }
    $num = 1;
    while ($row = $db->sql_fetchrow($result)) { 
           $template->assign_block_vars('top_poster', array(
                'POSTER_NUM' => $num++, 
                'POSTER_NAME' => $row['username'], 
                'POSTER_POST' => $row['user_posts'], 
                'POSTER_URL' => append_sid("profile.php?mode=viewprofile&u=".$row['user_id']))
           );
    }
//-------------------------------------------------------------------------- ֱٵ ȸ
    $sql = "SELECT user_id,username,user_regdate,user_gender,user_view_gender FROM " . USERS_TABLE . " WHERE user_id NOT IN (-1) ORDER BY user_regdate DESC LIMIT $ezm_m[14]"; 
    if (!($result = $db->sql_query($sql))) 
    {
	    message_die(GENERAL_ERROR, 'ֱٵ ȸ  ', '', __LINE__, __FILE__, $sql);
    } 
    $num = 1;
    while ($row = $db->sql_fetchrow($result)) 
    { 
        $gender = '<img src="' . $images['none_img'] . '">'; 
        if (!empty($row['user_gender'])) 
        { 
            switch ($row['user_gender']) 
            { 
                case 1 : $gender = '<img src="' . $images['male'] . '">'; break; 
                case 2 : $gender = '<img src="' . $images['female'] . '">'; break; 
               default : $gender = '<img src="' . $images['hidden'] . '">'; 
            } 
        } 
        $template->assign_block_vars('new_member', array(
            'NEWMB_NUM' => $num++,
            'NEWMB_GENDER' => $gender,
            'NEWMB_NAME' => $row['username'], 
            'NEWMB_DATE' => date("m d",$row['user_regdate']), 
            'NEWMB_LINK' => append_sid("profile.php?mode=viewprofile&u=".$row['user_id']) ) 
        );
    }  
/*------------------------------------------------------------------------------------+
 |  ǥ ϴ κԴϴ..   Ʒ ڵ带 ϼ..`|
 +------------------------------------------------------------------------------------*/
    $poll = "SELECT count(vote_id) AS poll FROM " . VOTE_DESC_TABLE;
    $data = $db->sql_fetchrow($db->sql_query($poll));
    (!empty($data['poll'])) ? include($phpbb_root_path . 'last_poll.'.$phpEx) : $template->assign_block_vars('no_poll',array());

//-------------------------------------------------  ǥ ɼǺκ

    top_topic("$ezm_m[7]",topic_views,"$ezm_m[8]");    // α ȸ Խù
    top_topic("$ezm_m[9]",topic_replies,"$ezm_m[10]"); //   Խù

//------------------------------------------------------------------------- ðȸ
    $sql="SELECT COUNT(*) AS today_member FROM " . USERS_TABLE . " WHERE FROM_UNIXTIME(user_regdate,'%Y%m%d') - FROM_UNIXTIME(unix_timestamp(NOW()),'%Y%m%d') = 0"; 
    if (!($result = $db->sql_fetchrow($db->sql_query($sql)))) {
	    message_die(GENERAL_ERROR, 'ðȸ  ', '', __LINE__, __FILE__, $sql);
    }
    $today_register = $result['today_member'];

	$template->assign_vars(array(
		'TOTAL_POSTS' => sprintf($l_total_post_s, $total_posts),
		'TOTAL_USERS' => sprintf($l_total_user_s, $total_users),
		'NEWEST_USER' => sprintf($lang['Newest_user'], '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$newest_uid") . '">', $newest_user, '</a>'), 
        'TODAY_REGISTER' => $today_register,

        'USERS_TODAY_LIST' => $users_today_list,
        'USERS_LASTHOUR' =>($users_lasthour)?sprintf($lang['Users_lasthour_explain'],$users_lasthour):$lang['Users_lasthour_none_explain'],
        'USERS_TODAY' =>$l_today_users,
        'TODAY_TOTAL' => $l_today_t_users,
        'L_TODAY_ATTEND' => $lang['today_attend'],
        'L_TODAY_VISIT' => $lang['today_visit'],
        'U_COUNTER' => '<a href="' . append_sid("counter_stats.php") . '">' . '<img src="'.  $images['more'] .'" alt="" border="0" />'.'</a>',

        'L_BIRTH_TODAY' => $lang['Birthday_today'],
        'L_BIRTH_WEEK' => sprintf($lang['Birthday_week'], $board_config['birthday_check_day']),
        'WHOSBIRTHDAY_WEEK' => ($board_config['birthday_check_day']>1) ? sprintf((($birthday_week_list)? $birthday_week_list:$lang['Nobirthday_week']),$board_config['birthday_check_day']) : '', 
        'WHOSBIRTHDAY_TODAY' =>($board_config['birthday_check_day']) ?($birthday_today_list)? $birthday_today_list:$lang ['Nobirthday_today'] : '', 
 
		'L_ONLINE_EXPLAIN' => $lang['Online_explain'], 

		'NAV_CAT_DESC' => $nav_cat_desc)
	);

	//
	// Okay, let's build the index
	
//
// Generate the page
//
$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>